/***************************************************************************
                          addressbook.cpp  -  description
                             -------------------
    begin                : Fri Apr 20 2001
    copyright            : (C) 2001 by Christian Fricke & Rene Maerten
    email                : cfricke@kcommander.org
 ***************************************************************************/
// $Revision: 1.5 $
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "addressbook.h"
#include "resource.h"
#include <klocale.h>
#include <qpopupmenu.h>
#include <kglobal.h>
#include <kstddirs.h>

addressbook::addressbook(QWidget *parent, const char *name) : QDialog( parent, name,TRUE)
{
  setCaption("KCommander2 Addressbook");

  // first we search for KMail addressbook

  //fux
  // das gehrt hier nicht zum addressbook sondern zur mailconfig
  KStandardDirs *dirs = KGlobal::dirs();
  QString config_path = dirs->findResourceDir("config","kmailrc");
  config_path += "kmailrc";


  QString path = QDir::homeDirPath() + "/.kde2/share/apps/kmail/addressbook";

  QString line;
  lv = new QListView(this);
  lv->addColumn(i18n("Username"));
  lv->addColumn(i18n("EMail address"));
  // POZOR !!
  // schauen ob file existiert....
  QFile ab(path);
  ab.open(IO_ReadOnly);
  while(!ab.atEnd())
  {
    ab.readLine(line,255);
    line = line.left(line.length()-1);
    // here we split name / email
    QString name, email;
    if(line.find("<") == -1)
    {
        // the name and email are the same
        name = i18n("<no name given>");
        email = line;
    }
    else
    {
        name = line.left(line.find("<"));
        email = line.right(line.length()-name.length());
    }
    // and now cut the ` " ` from the name (inserted by the ford-mail-server)
    while(name.find("\"") != -1)
      name.remove(name.find("\""),1);
    if(email.left(1) != "#")
    {
      QListViewItem *item = new QListViewItem(lv,name);
      item->setText(1,email);
    }
  }
  le = new QLineEdit(this);

  pb1 = new QPushButton(this);
	pb1->setText(i18n("Add to book"));
  pb2 = new QPushButton(this);
	pb2->setText(i18n("Accept"));
	
	
  resize(500,425);
	
	connect(pb1,SIGNAL(clicked()),this,SLOT(addMail()));
	connect(pb2,SIGNAL(clicked()),this,SLOT(accept()));
	
	connect(lv,SIGNAL(pressed(QListViewItem *)),this,SLOT(setSelection(QListViewItem *)));
}
addressbook::~addressbook(){
}

QString addressbook::getDestination()
{
  return le->text();
}

void addressbook::resizeEvent(QResizeEvent *e)
{
  lv->setGeometry(0,0,width(),height()-60);
  le->setGeometry(0,height()-28-30,width(),26);
  pb1->setGeometry(0,height()-28,width()/2,26);
  pb2->setGeometry(width()/2,height()-28,width()/2,26);
}


void addressbook::setSelection(QListViewItem *item)
{
	le->setText("\"" + item->text(0) +"\"" + item->text(1));
}

void addressbook::addMail()
{
  // add the given address to KMail addressbook and use it

  QFile file(QDir::homeDirPath() + "/.kde2/share/apps/kmail/addressbook");
  if(file.open(IO_ReadWrite | IO_Append))
  {
    QString address(le->text() + "\n");
    file.writeBlock(address,address.length());
    file.close();
  }
  accept();
}
