/***************************************************************************
                          dlgstartmenu.cpp  -  description
                             -------------------
    begin                : Sun Feb 4 2001
    copyright            : (C) 2001 by Rene Mrten & Christian Fricke
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          dlgstartmenu.cpp  -  description
                             -------------------
    begin                : Sat Oct 23 1999
    copyright            : (C) 1999 by Rene Mrten, Christian Fricke
    email                : @-Mail to: delta_x@LinuxCoding.DE
                                      cfricke@LinuxCoding.DE
****************************************************************************/

#include "dlgstartmenu.h"
#include <kfiledialog.h>

dlgStartmenu::dlgStartmenu(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	setMinimumSize(470,400);
	setMaximumSize(470,400);
	setCaption(i18n("Edit Start-Menu"));
	QListBox_2->hide();
	QListBox_3->hide();
	
	connect(QPushButton_1,SIGNAL(clicked()),this,SLOT(closeClicked()));
	connect(QPushButton_2,SIGNAL(clicked()),this,SLOT(delClicked()));
	connect(QPushButton_3,SIGNAL(clicked()),this,SLOT(newClicked()));
	connect(QPushButton_4,SIGNAL(clicked()),this,SLOT(browseClicked()));

	connect(QLineEdit_1,SIGNAL(returnPressed(const QString &)),SLOT(titelReturn(const QString &)));
	connect(QLineEdit_2,SIGNAL(returnPressed(const QString &)),this,SLOT(appReturn(const QString &)));
	connect(QLineEdit_3,SIGNAL(returnPressed(const QString &)),this,SLOT(paramReturn(const QString &)));
	
	connect(QLineEdit_1,SIGNAL(textChanged(const QString&)),this,SLOT(titelEd(const QString&)));
	connect(QLineEdit_2,SIGNAL(textChanged(const QString&)),this,SLOT(appEd(const QString&)));
	connect(QLineEdit_3,SIGNAL(textChanged(const QString&)),this,SLOT(paramEd(const QString&)));
	
	connect(QComboBox_1,SIGNAL(activated( const QString&)),this,SLOT(comboActivated( const QString&)));

	connect(QListBox_1,SIGNAL(clicked(QListBoxItem*)),this,SLOT(titelSelected(QListBoxItem*)));
//	connect(QListBox_2,SIGNAL(highlighted(int)),this,SLOT(appSelected(int)));
//	connect(QListBox_3,SIGNAL(highlighted(int)),this,SLOT(paramSelected(int)));
	
//	QPushButton_2->setEnabled(false);
	KConfig *config = kapp->config();
	config->setGroup("Startmenu");
	QString s;
	bool flag=true;
	int i=0;
	while(flag)
	{
		s.sprintf("Menutitle%d",i);
		QString titel = config->readEntry(s,"");
		if(titel == "") break;
		QListBox_1->insertItem(titel);
		s.sprintf("MenuApp%d",i);
		titel = config->readEntry(s,"");
		QListBox_2->insertItem(titel);
		s.sprintf("MenuParam%d",i++);
		titel = config->readEntry(s,"");
		QListBox_3->insertItem(titel);
	}
	if(QListBox_1->count())
		QListBox_1->setCurrentItem(0);
}

dlgStartmenu::~dlgStartmenu(){
}


void dlgStartmenu::comboActivated( const QString &s)
{
	if(strcmp(QLineEdit_3->text(),i18n("new Param")) == 0)
		QLineEdit_3->setText("");
	QString source(QLineEdit_3->text());
	QString ss(s);
	ss = ss.left(2) + " ";
	source.insert(QLineEdit_3->cursorPosition(),ss);
	QLineEdit_3->setText(source);
	QListBox_3->changeItem(source,QListBox_3->currentItem() );
	QLineEdit_1->setFocus();
}


void dlgStartmenu::closeClicked()
{
	save();
	this->accept();
}

void dlgStartmenu::closeEvent ( QCloseEvent * e )
{
	save();
	e->accept();
}
void dlgStartmenu::save()
{
	KConfig *config = kapp->config();
	config->setGroup("Startmenu");
	QString s;
	unsigned int i;
	for(i = 0;i < QListBox_1->count();i++)
	{
		s.sprintf("Menutitle%d",i);
		config->writeEntry(s,QListBox_1->text(i));
		s.sprintf("MenuApp%d",i);
		config->writeEntry(s,QListBox_2->text(i));
		s.sprintf("MenuParam%d",i);
		config->writeEntry(s,QListBox_3->text(i));
	}
	s.sprintf("Menutitle%d",i);
	config->writeEntry(s,"");
}

void dlgStartmenu::delClicked()
{
	QListBox_2->removeItem(QListBox_2->currentItem());
	QListBox_3->removeItem(QListBox_3->currentItem());
	QListBox_1->removeItem(QListBox_1->currentItem());

	if(QListBox_1->count() == 0)
	{
		QLineEdit_1->setText("");
		QLineEdit_2->setText("");
		QLineEdit_3->setText("");
//		QPushButton_2->setEnabled(false);
		return;
	}

}
void dlgStartmenu::newClicked()
{
	QListBox_2->insertItem(i18n("new App"));
	QListBox_3->insertItem(i18n("new Param"));
	QListBox_1->insertItem(i18n("new Entry"));
	QListBox_1->setCurrentItem(QListBox_1->count()-1);
}

void dlgStartmenu::titelEd(const QString &text)
{
		QListBox_1->changeItem(text,QListBox_1->currentItem() );
}

void dlgStartmenu::appEd(const QString &text)
{
		QListBox_2->changeItem(text,QListBox_1->currentItem());
}

void dlgStartmenu::paramEd(const QString &text)
{
		QListBox_3->changeItem(text,QListBox_1->currentItem());
}

void dlgStartmenu::titelSelected(QListBoxItem *item)
{
	if(!item) return;
	QString e2,e3;
	e2 = QListBox_2->text(QListBox_1->index(item));
	e3 = QListBox_3->text(QListBox_1->index(item));
		QLineEdit_1->setText(item->text());
		QLineEdit_2->setText(e2);
		QLineEdit_3->setText(e3);
}
void dlgStartmenu::appSelected(int index)
{
		QLineEdit_2->setText(QListBox_2->text(index));
}
void dlgStartmenu::paramSelected(int index)
{
		QLineEdit_3->setText(QListBox_3->text(index));
}

void dlgStartmenu::browseClicked()
{
	
	QString s;
	KFileDialog *browseFile;
	browseFile = new KFileDialog("/","",this,"name",true);
	s = browseFile->getOpenFileName();
	
	if(s.length() != 0)
	{
		QLineEdit_2->setText(s);
		QListBox_2->changeItem(s,QListBox_2->currentItem() );
	}
}

void dlgStartmenu::titelReturn(const QString &)
{
	QLineEdit_2->setFocus();
}
void dlgStartmenu::appReturn(const QString &)
{
	QLineEdit_3->setFocus();
}
void dlgStartmenu::paramReturn(const QString &)
{
	QLineEdit_1->setFocus();
}
