/***************************************************************************
                          filebasisview.cpp  -  description
                             -------------------
    begin                : Sun Feb 4 2001
    copyright            : (C) 2001 by Rene Mrten & Christian Fricke
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kapp.h>
#include <kaction.h>
#include <kcmdlineargs.h>
#include <kconfig.h>
#include <kdebug.h>
#include <kdesktopfile.h>
#include <kglobal.h>
#include <kglobalsettings.h>
#include <kiconloader.h>
#include <kio/job.h>
#include <kio/renamedlg.h>
#include <kio/skipdlg.h>
#include <klocale.h>
#include <kmessagebox.h>
#include <kmimetype.h>
#include <kprocess.h>
#include <kstddirs.h>
#include <ktoolbar.h>
#include <ktoolbarbutton.h>
#include <kurl.h>
#include <kfileview.h>
#include <krecentdocument.h>

#include "filebasisview.h"
#include "kcommander2view.h"
#include "inputbox.h"

#include <kfileiconview.h>
#include <kfiledetailview.h>
#include <kcombiview.h>
#include <kfilefilter.h>
#include <kfilebookmark.h>
#include "diroperator.h"
#include "mailer.h"
#include <kstaticdeleter.h>
#include <ktar.h>
#include <qfileinfo.h>
#include <kpropsdlg.h>
#include <kopenwith.h>
#include <kmailIface.h>
#include <dcopclient.h>

template class QList<KIO::StatJob>;

struct FileBasisViewPrivate
{
    KURL url;
    QString filenames;
    QString selection;
    QString completionHack;
    bool showStatusLine;
    QWidget *mainWidget;

    QList<KIO::StatJob> statJobs;

    bool completionLock;

    KURL::List urlList; //the list of selected urls

    KMimeType::Ptr defaultType; // the default mimetype to save as
    KMimeType::List mimetypes; //the list of possible mimetypes to save as
};

KURL *FileBasisView::lastDirectory; // to set the start path

static KStaticDeleter<KURL> ldd;

FileBasisView::FileBasisView(bool mod,const QString& dirName, const QString& filter,
                         QWidget *parent, const char* name, bool)
			:QDialog(parent,name,false),boxLayout(0)
{
	  	setAcceptDrops(true);
  		appName = name;

    mainWidget = new QWidget(parent);
    QFont f,def;
  	KConfig *config = kapp->config();
	  config->setGroup("FontConfig");
	  f = config->readFontEntry("Font_0",&def);
    mainWidget->setFont(f);

    KURL u;
    u.setPath( QDir::rootDirPath() );
    QString text = i18n("Root Directory: %1").arg( u.path() );

    u.setPath( QDir::homeDirPath() );
    text = i18n("Home Directory: %1").arg( u.path( +1 ) );

    u.setPath( KGlobalSettings::desktopPath() );
    text = i18n("Desktop: %1").arg( u.path( +1 ) );

    if (!lastDirectory)
    {
        lastDirectory = ldd.setObject(new KURL());
    }

    if (!dirName.isEmpty())
        *lastDirectory = KCmdLineArgs::makeURL( QFile::encodeName(dirName) );
    else
        if (lastDirectory->isEmpty())
            *lastDirectory = QDir::currentDirPath();

//muesste noch konfigurierbar gemacht werden, fuer Rechner, die staendig im Netz sind !!!!!!!!!!!!!!!!1
  if(!lastDirectory->isLocalFile())
    *lastDirectory = KCmdLineArgs::makeURL( QFile::encodeName("/home/"+QDir::home().dirName()));
//	if(lastDirectory->protocol() == "ftp")
//	{
//		lastDirectory->setUser("anonymous");
//		lastDirectory->setPass("cfricke@codewizards.org");
//	}
  url = *lastDirectory;

  if (mod)
  {

	focus = new QPushButton(mainWidget,"focusedView");
	focus->setFocusPolicy(NoFocus);
	focus->setMinimumSize(200,20);
	focus->setMaximumHeight(20);
	connect(focus,SIGNAL(clicked()),SLOT(setViewFocus()));
	
	bookButton = new QToolButton(mainWidget,"bookMarks");
	bookButton->setFocusPolicy(NoFocus);
	bookButton->setMinimumSize(20,20);
	bookButton->setMaximumSize(20,20);
	bookButton->setText("B");
	connect(bookButton,SIGNAL(clicked()),SLOT(slotShowBooks()));
	
		driveList = new QComboBox(mainWidget, "1" );
		driveList->setFocusPolicy(NoFocus);
		connect(driveList,SIGNAL( activated( const QString & )),SLOT(driveActivated (const QString &)));
		driveList->setMaximumSize(100,20);
		driveList->setFocusPolicy(NoFocus);
		QFile f("/etc/fstab");
		if ( f.open(IO_ReadOnly) ) {    // file opened successfully
			QTextStream t( &f );        // use a text stream
			QString s;
			while ( !t.eof() ) {        // until end of file...
				s = t.readLine();       // line of text excluding '\n'
				s = s.simplifyWhiteSpace();
				if(s.at(0) == '/')
				{
					if(s.find("SwAP",0,false) == -1)
					{
						// in S msste jetzt nur ein Device stehen, was auch Datentrger ist
						// zuerst mal das erste Leerzeichen finden
						int z = s.find(" /");		// nach Leerzeichen suchen
						if(z == -1)							// wenn z immernoch -1, dann raus hier !
						 break;
						s = s.right(s.length()-z-1);
						z = s.find(" ");
						if( z == -1)
						 break;
						kapp->processEvents();
						s = "[" + s.left(z) + "]";
						driveList->insertItem(s);
					}
				}
			}
			f.close();
		}
  }

	upperBox = new QGridLayout(1,5,1);
	lowerBox = new QGridLayout(1,4,1);
	// merken deleten nicht vergessen !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	// Arno, unter QT brauchst Du Widgets NICHT deleten !!!
	
	boxLayout = new QVBoxLayout(mainWidget,2); //wird noch schick gemacht
	boxLayout->addLayout(upperBox,1);
	if(mod)
	{	
//void addMultiCellWidget ( QWidget *, int fromRow, int toRow, int fromCol, int toCol, int align = 0 )
	  upperBox->addMultiCellWidget(focus,0,0,2,5);
	  upperBox->addWidget(bookButton,0,1);
	  upperBox->addWidget(driveList,0,0);
	}
	boxLayout->addSpacing(3);
	boxLayout->activate();


    ops = new DirOperator(url, mainWidget, "KArnoFileDialog::ops");
		connect(ops,SIGNAL(hatFocus()),SLOT(setViewFocus()));
		connect(ops,SIGNAL(hatKeinFocus()),SLOT(setLostFocus()));
		boxLayout->addWidget(ops, 18);
		if(!mod)
		{
			ops->setMaximumWidth(1);
			ops->setFocusPolicy(NoFocus);
		}
    ops->setOnlyDoubleClickSelectsFiles( true );
    ops->setMode(KFile::Files);

//    connect(ops, SIGNAL(updateInformation(int, int)),
//            SLOT(updateStatusLine(int, int)));
    connect(ops, SIGNAL(urlEntered(const KURL&)),            			SLOT(urlEntered(const KURL&)));
    connect(ops, SIGNAL(fileHighlighted(const KFileViewItem *)),  SLOT(fileHighlighted(const KFileViewItem *)));
    connect(ops, SIGNAL(fileSelected(const KFileViewItem *)),     SLOT(fileSelected(const KFileViewItem *)));
    connect(ops, SIGNAL(finishedLoading()),                       SLOT(slotLoadingFinished()));
    connect(ops, SIGNAL(renameFile()),                            SLOT(slotRenameFile()));
    connect(ops, SIGNAL(sendFile()),                            SLOT(slotSendFile()));
    connect(ops, SIGNAL(openWithSignal()),                        SLOT(slotOpenWith()));
//    connect(ops, SIGNAL(bookmarkSignal()),                        SLOT(bookMark()));
    connect(ops,SIGNAL(droppedFiles(QStringList)),SLOT(dropped(QStringList)));

  listInfoLabel = new QLabel(mainWidget,"InfoLabel");
	lowerBox->addWidget(listInfoLabel,1,0,4);
	
	boxLayout->addLayout(lowerBox,1);

  KSimpleConfig *kc = new KSimpleConfig(QString::fromLatin1(appName),
                                          false);
  QString oldGroup = kc->group();
  kc->setGroup( ConfigGroup );
  showStatusLine = kc->readBoolEntry(ConfigShowStatusLine,
                                          DefaultShowStatusLine);

  readRecentFiles( KGlobal::config() );

  readConfig( kc, ConfigGroup );
  delete kc;

  setFilter(filter);
  ops->setView(KFile::Default,mod);
}

FileBasisView::~FileBasisView()
{
    *lastDirectory = ops->url();
    KSimpleConfig *c = new KSimpleConfig(QString::fromLatin1(appName),
                                         false);
    saveConfig( c, ConfigGroup );
    saveRecentFiles( KGlobal::config() );
    delete c;

    delete ops;
//    delete d;
}

void FileBasisView::show()
{
    QWidget::show();
}

void FileBasisView::fileSelected(const KFileViewItem *item)
{
 // kc is crashing on some fileactions...didn't know which !!
 if(checkIfTarBall(item))
  return;
 const KURL myurl(item->url());
 run = new KRun(myurl);
}

bool FileBasisView::checkIfTarBall(const KFileViewItem *item)
{
	QString tmp(item->urlString());
	if(KURL(tmp).protocol() == "tar")
	  return false;
	
	// this both are the only significations for tgz-archives
	if(tmp.right(4)== ".tgz" || tmp.right(7) == ".tar.gz")
	{
		QString tmp1 = tmp.right(tmp.length()-1-tmp.find(":"));
		tmp1 = "tar://" + tmp1;
		KURL tmpURL(tmp1);
		setURL(KURL(tmpURL));
		return true;
	}
	return false;
}

void FileBasisView::readConfig( KConfig *kc, const QString& group )
{
    if ( !kc )
        return;

    QString oldGroup = kc->group();
    if ( !group.isEmpty() )
        kc->setGroup( group );

    ops->readConfig( kc, group );

    autoDirectoryFollowing = kc->readBoolEntry( AutoDirectoryFollowing,
                                                DefaultDirectoryFollowing );

    kc->setGroup( oldGroup );
}

void FileBasisView::saveConfig( KConfig *kc, const QString& group )
{
    if ( !kc )
        return;

    QString oldGroup = kc->group();
    if ( !group.isEmpty() )
        kc->setGroup( group );

    ops->saveConfig( kc, group );
    kc->setGroup( oldGroup );
    kc->sync();
}

void FileBasisView::readRecentFiles( KConfig *kc )
{
    QString oldGroup = kc->group();
    kc->setGroup( ConfigGroup );
    kc->reparseConfiguration();
    kc->setGroup( oldGroup );
}

void FileBasisView::saveRecentFiles( KConfig *kc )
{
    QString oldGroup = kc->group();
    kc->setGroup( ConfigGroup );
    kc->sync();
    kc->setGroup( oldGroup );
}

void FileBasisView::slotLoadingFinished()
{
    if ( !selection.isNull() )
        ops->setCurrentItem( selection );
    updateInfoLabel();
}

void FileBasisView::urlEntered(const KURL &)
{
	QString focText = ops->url().path();
	QDir::setCurrent(ops->url().directory());	
	if(focText.length()> 33)
		focus->setText(focText.left(14)+"...."+focText.right(14));
	else
	focus->setText(focText);
	emit(urlNew());
}

void FileBasisView::setViewFocus()
{
	QString focText = ops->url().path();
	ops->setFocus();
	if(focText.length()> 33)
		focus->setText(focText.left(14)+"...."+focText.right(14));
	else
  	focus->setText(focText);
	focused = true;
	emit focussed();
}

void FileBasisView::setLostFocus()
{
	focused = false;
}

void FileBasisView::driveActivated(const QString &drive)
{
	QString ss(drive);
	ss = ss.mid(1,ss.length()-2);
	KURL newURL(ss);
	ops->setURL(newURL,false);
	setViewFocus();
}

void FileBasisView::fileHighlighted(const KFileViewItem *)
{
	updateInfoLabel();
}

void  FileBasisView::resizeEvent(QResizeEvent *)
{
}

void  FileBasisView::updateInfoLabel()
{
	QString s;
  s.sprintf("%d Dirs / %d Files    %d selected",
              ops->numDirs()-1,ops->numFiles(),selectedFiles()->count());
  listInfoLabel->setText(s);
}

void FileBasisView::keyPressEvent(QKeyEvent *e)
{
  e->ignore();
}

KFileViewItemList* FileBasisView::selectedFiles() const
{
	return const_cast<KFileViewItemList*>(ops->selectedItems());
}

void FileBasisView::focusInEvent( QFocusEvent *)
{
}

void FileBasisView::changeFocusState(bool flag)
{
	if(flag)
  {
    	focus->setBackgroundColor(QColor(0xa0a0ff));
  }
	else
  {
    	focus->setBackgroundColor(backgroundColor());
  }
}

void FileBasisView::setMode( KFile::FileView m )
{
	ops->setView(m,false);
}

void FileBasisView::mkDir()
{	
	ops->mkdir();
}

void FileBasisView::setToggleHidden(bool show)
{	
	ops->slotToggleHidden(show);
}

void FileBasisView::setURL(const KURL &url, bool)
{
	ops->setURL(url,false);
}

QString FileBasisView::currentDir(){return ops->url().url();}

KFileItem* FileBasisView::findByName( const QString& name ) const
{
	return ops->findByName(name);
}

void FileBasisView::slotRenameFile()
{
	if(!selectedFiles()->first()) return;
	 KFileItem *test = selectedFiles()->first();
	 KPropertiesDialog *props = new  KPropertiesDialog(test,this,i18n("Properties"),true);
	 props->exec();
}

void FileBasisView::slotSendFile()
{
	if(!selectedFiles()->first())
	  return;
  KFileItem *test = selectedFiles()->first();
  addressbook *ab = new addressbook();
  ab->exec();

  QString adr = ab->le->text();
  delete(ab);
// nur Locale Files bitte !!
  Mailer *mail = new Mailer(adr,test->url().path(),test->name());
  connect(mail,SIGNAL(changeStatus(const QString &)),SLOT(slotChangeStatus(const QString &)));
//  mail->exec();
}
void FileBasisView::slotChangeStatus(const QString &statusText)
{
  emit changeStatus(statusText);
}
void FileBasisView::slotOpenWith()
{
	if(!selectedFiles()->first()) return;
	KURL::List liste;
	liste.append(selectedFiles()->first()->url());
	KFileOpenWithHandler handle;
	handle.displayOpenWithDialog (liste);
}

void FileBasisView::bookMark()
{
	KConfig *config = kapp->config();
	config->setGroup("Assignments");
}

void FileBasisView::slotShowBooks()
{
	QPopupMenu *menu = new QPopupMenu(0,"1");
	KCommander2View::fillDriveAssigns(menu);
  connect(menu,SIGNAL(activated(int)),this,SLOT(bookMenuActivated (int)));
	menu->popup(QPoint(kapp->activeWindow()->x()+kapp->activeWindow()->width()/2-50,kapp->activeWindow()->y()));
}
		
void FileBasisView::bookMenuActivated (int akey)
{
	KConfig *config = kapp->config();
	config->setGroup("Assignments");
	QString path;
	QString titel2;
   QString s;
   s.sprintf("DriveAssign%c", akey + 'A');
	path = config->readEntry(s,"");
   if(path == "")
      return;
   path += "/";
	setURL(KURL(path),true);
}

void FileBasisView::highlightFile(const KFileViewItem*i)
{
	ops->highlightFile(i);
}

void FileBasisView::dropped(QStringList list)
{
	// ok, zuerstmal nen mousemoveevent einbauen, damit wir wissen, wo genau der
	// drop stattfand
	emit droppedFiles(list);
}

void FileBasisView::dragMoveEvent(QDragMoveEvent *)
{
//  QRect r = e->answerRect();
}
void FileBasisView::dragEnterEvent(QDragEnterEvent* event)
{
    event->accept( QTextDrag::canDecode(event) || QImageDrag::canDecode(event) );
}

KFileViewItem FileBasisView::currentItem()
{
// selectedItems() gibt eine Liste her -- Ich will das erste davon haben !!!
//	if(!selectedFiles()->first()) return;
	 KFileViewItem *test = selectedFiles()->first();
	 return *test;
}

QWidget* FileBasisView::widget()
{
	return mainWidget;
}

void FileBasisView::setFilter(const QString& filter)
{
	ops->setNameFilter(filter);
}

void FileBasisView::setSelection(QString selString)
{
	ops->setSelection(selString);
}
void FileBasisView::setSelectionAll()
{
	ops->setSelectionAll();
}
void FileBasisView::setSelectionInvert()
{
	ops->setSelectionInvert();
}
void FileBasisView::setSelectionNone()
{
	ops->setSelectionNone();
}


// DCOP Functions ....

QCStringList FileBasisView::interfaces()
{
	QCStringList *list = new QCStringList;
	return *list;
}
QCStringList FileBasisView::functions()
{
	QCStringList *list = new QCStringList;
	return *list;
}

//bool FileBasisView::process(const QCString &qcs, const QByteArray &array, QCString &string, QByteArray &array2)
bool FileBasisView::process(const QCString &, const QByteArray &, QCString &, QByteArray &)
{
  return true;
}
void FileBasisView::cdUp()
{
  ops->cdUp();
}
