/***************************************************************************
                          filereader.h  -  description
                             -------------------
    begin                : Sun Feb 4 2001
    copyright            : (C) 2001 by Rene Mrten & Christian Fricke
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// -*- c++ -*-
/* This file is part of the KDE libraries
    Copyright (C) 1997, 1998 Richard Moore <rich@kde.org>
                  1998,1999,2000 Stephan Kulow <coolo@kde.org>
                  1998 Daniel Grana <grana@ie.iwi.unibe.ch>
		  1999,2000 Carsten Pfeiffer <pfeiffer@kde.org>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef FILEREADER_H
#define FILEREADER_H

#include <qstring.h>

#include "dirlister.h"
#include <kurl.h>

#include <kfileviewitem.h>

class FileReader : public DirLister
{
    Q_OBJECT

public:
    FileReader();
    FileReader(const KURL& url, const QString& nameFilter= QString::null);
    ~FileReader();

    bool isRoot() const { return url().path() == QChar('/'); }

    bool isReadable() const;

protected:
  virtual KFileItem * createFileItem( const KIO::UDSEntry&, const KURL&, bool );

private:
    void init();

    FileReader(const FileReader&);
    FileReader& operator=(const FileReader&);

private:
    class FileReaderPrivate;
    FileReaderPrivate *d;

};
#endif
