/***************************************************************************
                          kcommander2.cpp  -  description
                             -------------------
    begin                : Sun Sep 17 12:25:22 GMT 2000
    copyright            : (C) 2000 by Rene Mrten / Christian Fricke
    email                : cfricke@codewizards.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>

// include files for KDE
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <klocale.h>
#include <kconfig.h>
#include <kprocess.h>
#include <kpropsdlg.h>
#include <dcopclient.h>
// application specific includes
#include "kcommander2.h"
#include "kcommander2view.h"
#include "kcommander2doc.h"
#include "resource.h"
#include "dlgstartmenu.h"
#include "dlgeditassigns.h"
#include "dlgsplit.h"
#include "aboutwindow.h"

KCommander2App::KCommander2App()
{
  config=kapp->config();
	
//  setIcon(QPixmap(KIconLoader::loadIcon("kcommander2.png",KIcon::Panel)));
  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initMenuBar();
  initStatusBar();
  initKeyAccel();
  initDocument();
  initView();
  initToolBar();
	
  readOptions();
  DCOPClient *client = kapp->dcopClient();
  client->attach();
  client->registerAs("KCommander2");
}

KCommander2App::~KCommander2App()
{
}

void KCommander2App::initKeyAccel()
{
  keyAccel = new KAccel(this);
	
  keyAccel->connectItem(KStdAccel::Quit, this, SLOT(slotFileQuit()));
  keyAccel->connectItem(KStdAccel::Help, this, SLOT(appHelpActivated()));
			
  keyAccel->changeMenuAccel(fileMenu, ID_FILE_QUIT, KStdAccel::Quit);

  keyAccel->readSettings();	
}

void KCommander2App::initMenuBar()
{
  fileMenu = new QPopupMenu();
  fileMenu->insertItem(kapp->miniIcon(), i18n("New &Window"), ID_FILE_NEW_WINDOW);
  fileMenu->insertSeparator();
  fileMenu->insertItem(i18n("C&ompress..."), ID_MENU_PACK );
//    fileMenu->setItemEnabled(ID_MENU_PACK,false);
  fileMenu->insertItem(i18n("&Test Archieve(s)..."),ID_MENU_TESTARC );
  	fileMenu->setItemEnabled(ID_MENU_TESTARC,false);
  fileMenu->insertItem(i18n("&Symlinks..."),ID_MENU_MAKELINK );
	  fileMenu->setItemEnabled(ID_MENU_MAKELINK,false);
  fileMenu->insertItem(i18n("Fileproperties..."), ID_MENU_FILEATTR );
//    fileMenu->setItemEnabled(ID_MENU_FILEATTR,false);
  fileMenu->insertItem(i18n("&Get Diskspace..."), ID_MENU_GETMEM );
    fileMenu->setItemEnabled(ID_MENU_GETMEM,false);
  fileMenu->insertItem(i18n("&Print"), ID_MENU_PRINT );
    fileMenu->setItemEnabled(ID_MENU_PRINT,false);
  fileMenu->insertSeparator();
  fileMenu->insertItem(i18n("Sp&lit Files..."), ID_MENU_SPLITFILE );
//    fileMenu->setItemEnabled(ID_MENU_SPLITFILE,false);
  fileMenu->insertItem(i18n("&Join Files..."), ID_MENU_JOINFILE );
    fileMenu->setItemEnabled(ID_MENU_JOINFILE,false);
  fileMenu->insertItem(i18n("&Code Files (MIME, UUE, XXE )..."), ID_MENU_CODING );
	  fileMenu->setItemEnabled(ID_MENU_CODING,false);
  fileMenu->insertItem(i18n("Decode Files (MIME, UUE, XXE, BinHex)..."), ID_MENU_DECODING );
    fileMenu->setItemEnabled(ID_MENU_DECODING,false);
  fileMenu->insertSeparator();
  fileMenu->insertItem(i18n("E&xit"), ID_FILE_QUIT);
	
	////////////////////////////////////////////////////////////////////////////////////////////
	// menuBar entry markmenu
	markMenu = new QPopupMenu();
  markMenu->insertItem( i18n("&Mark Group..."), ID_MENU_MARKGROUP );
//    markMenu->setItemEnabled(ID_MENU_MARKGROUP,false);
  markMenu->insertItem( i18n("&Unmark Group..."), ID_MENU_REMARKGROUP );
//    markMenu->setItemEnabled(ID_MENU_REMARKGROUP,false);
  markMenu->insertItem( i18n("Mark All Files"), ID_MENU_MARKALL );
//    markMenu->setItemEnabled(ID_MENU_MARKALL,false);
  markMenu->insertItem( i18n("Unmark All Files"), ID_MENU_MARKNONE );
//    markMenu->setItemEnabled(ID_MENU_MARKNONE,false);
  markMenu->insertItem( i18n("Reverse Selection"), ID_MENU_MARKREVERSE );
//    markMenu->setItemEnabled(ID_MENU_MARKREVERSE,false);
  markMenu->insertSeparator();
  markMenu->insertItem( i18n("Compare Directorys"),ID_MENU_COMPDIR );
    markMenu->setItemEnabled(ID_MENU_COMPDIR,false);
	
	////////////////////////////////////////////////////////////////////////////////////////////
	// menuBar entry commandsmenu
	commandMenu = new QPopupMenu();
      commandMenu->insertItem( i18n("&Search..."), ID_MENU_SEARCHFILE );
      commandMenu->setItemEnabled(ID_MENU_SEARCHFILE,false);
      commandMenu->insertItem( i18n("System &Information..."),ID_MENU_SYSINFO );
      commandMenu->setItemEnabled(ID_MENU_SYSINFO,false);
//      commandMenu->insertItem( i18n("&Back"));
//      commandMenu->setItemEnabled(id,false);
      commandMenu->insertSeparator();
      commandMenu->insertItem( i18n("&Start A Shell"),ID_MENU_STARTTERM );
      commandMenu->insertSeparator();

      commandMenu->insertItem( i18n("Format Disk"),ID_MENU_FORMAT );
//      commandMenu->setItemEnabled(ID_MENU_FORMAT,false);
      commandMenu->insertSeparator();

      commandMenu->insertItem( i18n("&Network"),ID_MENU_NETWORK );
      commandMenu->setItemEnabled(ID_MENU_NETWORK,false);

//      commandMenu->insertItem( i18n("Mount SMB-Drives..."));
//      commandMenu->setItemEnabled(id,false);
//      commandMenu->insertItem( i18n("Umount SMB-Drives..."));
//      commandMenu->setItemEnabled(id,false);
      commandMenu->insertSeparator();
      commandMenu->insertItem( i18n("FT&P-Connection..."),ID_MENU_FTPCONNECT);
      commandMenu->insertItem( i18n("FTP &New Connection..."),ID_MENU_FTPNEW);
      commandMenu->insertItem( i18n("FTP-Close Connection..."),ID_MENU_FTPCLOSE);
      commandMenu->insertSeparator();
      commandMenu->insertItem( i18n("&Swap Listviews"),ID_MENU_SWAPLISTVIEWS );
//      commandMenu->setItemEnabled(ID_MENU_SWAPLISTVIEWS,false);
//      commandMenu->insertItem( i18n("Adjust Listviews "));
//      commandMenu->setItemEnabled(id,false);

  ///////////////////////////////////////////////////////////////////
  // menuBar entry viewMenu
  systemMenu = new QPopupMenu();
  systemMenu->insertItem( i18n("&Drives"),ID_MENU_SHOW_DRIVES);
//  systemMenu->setItemEnabled(ID_MENU_SHOW_DRIVES,false);
  systemMenu->insertItem( i18n("CPU"), ID_MENU_SHOW_CPU );
//  systemMenu->setItemEnabled(ID_MENU_SHOW_CPU,false);
  systemMenu->insertItem( i18n("Memory"), ID_MENU_SHOW_MEM );
//  systemMenu->setItemEnabled(ID_MENU_SHOW_MEM,false);
  systemMenu->insertItem( i18n("Was dir noch einfaellt"), ID_MENU_SHOW_MORE );
  systemMenu->setItemEnabled(ID_MENU_SHOW_MORE,false);

  viewMenu = new QPopupMenu();
//  viewMenu->setCheckable(true);
  viewMenu->insertItem(i18n("&Toolbar"), ID_VIEW_TOOLBAR);
  viewMenu->insertItem(i18n("&Statusbar"), ID_VIEW_STATUSBAR);
      viewMenu->insertItem( i18n("S&hort"),ID_VIEW_SHOW_SHORT );
      viewMenu->insertItem( i18n("&Long"),ID_VIEW_SHOW_LONG);
//      viewMenu->insertItem( i18n("&Directory Tree"));
//      viewMenu->setItemEnabled(id,false);
//      viewMenu->insertItem( i18n("Drivespace"),ID_MENU_DRIVESPACE );
//      	viewMenu->setItemEnabled(ID_MENU_DRIVESPACE,false);
//      viewMenu->insertItem( i18n("Memory Display"),ID_MENU_MEMORY );
//      	viewMenu->setItemEnabled(ID_MENU_MEMORY,false);
      viewMenu->insertSeparator();
      viewMenu->insertItem( i18n("&All"),ID_MENU_SHOW_ALL);
      	viewMenu->setItemEnabled(ID_MENU_SHOW_ALL,false);
      viewMenu->insertItem( i18n("Show Dirs"), ID_MENU_SHOW_DIRS );
      	viewMenu->setItemEnabled(ID_MENU_SHOW_DIRS,false);
      viewMenu->insertItem( i18n("Show Files"), ID_MENU_SHOW_FILES );
      	viewMenu->setItemEnabled(ID_MENU_SHOW_FILES,false);
      viewMenu->insertItem( i18n("Show Hidden"), ID_MENU_SHOW_HIDDEN );
      viewMenu->insertItem( i18n("Show Systemfiles"), ID_MENU_SHOW_SYSTEMFILES );
      	viewMenu->setItemEnabled(ID_MENU_SHOW_SYSTEMFILES,false);

//      viewMenu->insertItem( i18n("&User Defined..."));
//      viewMenu->setItemEnabled(id,false);
      viewMenu->insertSeparator();
      viewMenu->insertItem( i18n("By &Name"),ID_MENU_SORT_NAME);
      	viewMenu->setItemEnabled(ID_MENU_SORT_NAME,false);
      viewMenu->insertItem( i18n("By &Size"),ID_MENU_SORT_SIZE);
      	viewMenu->setItemEnabled(ID_MENU_SORT_SIZE,false);
      viewMenu->insertItem( i18n("By &Date/Time"),ID_MENU_SORT_DATE);
      	viewMenu->setItemEnabled(ID_MENU_SORT_DATE,false);
      	
      viewMenu->insertSeparator();
		viewMenu->insertItem(i18n("System"),systemMenu);
  ///////////////////////////////////////////////////////////////////
  // menuBar entry editMenu
  editMenu = new QPopupMenu();
  editMenu->insertItem( i18n("&Options..."),ID_MENU_OPTIONS);

  ///////////////////////////////////////////////////////////////////
  // menuBar entry editMenu
  startMenu = new QPopupMenu();
		QString s;
		config->setGroup("Startmenu");
		bool flag = true;
		int i=0;
		while(flag)
		{
			s.sprintf("Menutitle%d",i);
			QString titel = config->readEntry(s,"");
			if(titel == "") break;
			startMenu->insertItem(titel,ID_STARTMENU+i);
			i++;
		}
      startMenu->insertSeparator();
      startMenu->insertItem( i18n("Change Start Menu..."),ID_MENU_STARTER );
      startMenu->insertItem( i18n("Edit Path Assigns..."),ID_MENU_ASSIGNS );

  ///////////////////////////////////////////////////////////////////
  // menuBar entry helpMenu
//  helpMenu_ = helpMenu("KCommander2 1.91\n\n(c) 2000 by\nRene Mrten / Christian Fricke\ncfricke@codewizards.org");
	helpMenu2 = new QPopupMenu();
	helpMenu2->insertItem(i18n("&About"),ID_MENU_HELPABOUT);
	helpMenu2->insertItem(i18n("&Contents"),ID_MENU_HELPTHIS);

  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  // insert your popup menus with the according menubar entries in the order
  // they will appear later from left to right
  menuBar()->insertItem(i18n("&File"), fileMenu);
  menuBar()->insertItem(i18n("&Mark"), markMenu);
  menuBar()->insertItem(i18n("&Command"), commandMenu);
  menuBar()->insertItem(i18n("&View"), viewMenu);
  menuBar()->insertItem(i18n("C&onfigure"), editMenu);
  menuBar()->insertItem(i18n("S&tart Menu"), startMenu);
  menuBar()->insertItem(i18n("&Help"), helpMenu2);
  menuBar()->insertSeparator();

  ///////////////////////////////////////////////////////////////////
  // CONNECT THE MENU SLOTS WITH SIGNALS
  // for execution slots and statusbar messages
  connect(fileMenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(fileMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(markMenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(markMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(commandMenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(commandMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(editMenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(editMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(viewMenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(viewMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(systemMenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(systemMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(startMenu, SIGNAL(activated(int)), SLOT(commandStartMenu(int)));
  connect(startMenu, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
  connect(helpMenu2, SIGNAL(activated(int)), SLOT(commandCallback(int)));
  connect(helpMenu2, SIGNAL(highlighted(int)), SLOT(statusCallback(int)));
}

void KCommander2App::initToolBar()
{
	// if there any buttons, we delete them first
	for(int i=0;i<20;i++)
		if(toolBar()->getButton(TOOLBUTTON + i))
		  toolBar()->removeItem(TOOLBUTTON + i);
	
	KConfig *config;
	config = kapp->config();
	config->setGroup("KDE");
  config->writeEntry("SingleClick",false);
  config->sync();
  enableToolBar(KToolBar::Show);
	
	KIconLoader kil;
	config->setGroup("ToolButtons");
	QString temp, result;
	bool foundAny = false;
	for(int i=0;i<20;i++)
	{
		temp.sprintf("tb_%d_",i);
		result = config->readEntry(temp + "iconName","");
		// if namelength equal 0 we skip this button
		if(result.length() != 0)
		{
			// ok, we have found a configured button, so insert him
			// get the name
			QString name = result;
			// and the toolTip, thats all for the moment
			QString tooltip;
			tooltip = config->readEntry(temp + "ToolTip",tr("<no hints>"));
	    toolBar()->insertButton(	kil.loadIcon(name,KIcon::Desktop),
	    													TOOLBUTTON + i,
	    													true,
	    													tooltip);
			toolBar()->showItem(TOOLBUTTON + i);
			foundAny = true;
		}
	}
	if(!foundAny)
	{
		// nothing configured
		// lets add a separator
		toolBar()->insertSeparator();
	}
	toolBar()->show();
 	connect(toolBar(),SIGNAL(clicked(int)),SLOT(toolButtonPressed(int)));
 	connect(toolBar(), SIGNAL(pressed(int)), SLOT(statusCallback(int)));
}

void KCommander2App::initStatusBar()
{
  statusBar()->insertItem(i18n(IDS_STATUS_DEFAULT), ID_STATUS_MSG);
}

void KCommander2App::initDocument()
{
  doc = new KCommander2Doc(this);
  doc->newDocument();
}

void KCommander2App::initView()
{ 
  view = new KCommander2View(this);
  connect(view,SIGNAL(changeStatus(const QString &)),SLOT(slotStatusHelpMsg(const QString &)));
  doc->addView(view);
  setView(view);	
  setCaption(doc->getTitle());
}

void KCommander2App::enableCommand(int id_)
{
  menuBar()->setItemEnabled(id_, true);
}

void KCommander2App::disableCommand(int id_)
{
  menuBar()->setItemEnabled(id_, false);
}

KCommander2Doc *KCommander2App::getDocument() const
{
  return doc;
}

void KCommander2App::saveOptions()
{	
  config->setGroup("General Options");
  config->writeEntry("Geometry", size());
  config->writeEntry("Show Toolbar", toolBar()->isVisible());
  config->writeEntry("Show Statusbar",statusBar()->isVisible());
  config->writeEntry("ToolBarPos", (int) toolBar()->barPos());
  config->writeEntry("Recent Files", recentFiles);
}


void KCommander2App::readOptions()
{
	
  config->setGroup("General Options");

  // bar status settings
  bool bViewToolbar = config->readBoolEntry("Show Toolbar", true);
  viewMenu->setItemChecked(ID_VIEW_TOOLBAR, bViewToolbar);
  if(!bViewToolbar)
  {
     enableToolBar(KToolBar::Hide);
  }
	
  bool bViewStatusbar = config->readBoolEntry("Show Statusbar", true);
  viewMenu->setItemChecked(ID_VIEW_STATUSBAR, bViewStatusbar);
  if(!bViewStatusbar)
  {
    enableStatusBar(KStatusBar::Hide);
  }

  // bar position settings
  KToolBar::BarPosition toolBarPos;
  toolBarPos=(KToolBar::BarPosition) config->readNumEntry("ToolBarPos", KToolBar::Top);
  toolBar()->setBarPos(toolBarPos);
	
  // initialize the recent file list
  recentFiles.setAutoDelete(TRUE);
  config->readListEntry("Recent Files", recentFiles);
	
  for (int i=0; i < (int) recentFiles.count(); i++)
  {
    recentFilesMenu->insertItem(recentFiles.at(i));
  }

  QSize size=config->readSizeEntry("Geometry");
  if(!size.isEmpty())
  {
    if(size.width()>=640)
	    resize(size);
	  else
	  	resize(640,480);
  }
  else
  	resize(640,480);

}

void KCommander2App::saveProperties(KConfig *_cfg)
{
  if(doc->getTitle()!=i18n("Untitled") && !doc->isModified())
  {
    // saving to tempfile not necessary

  }
  else
  {
    QString filename=doc->getAbsFilePath();	
    _cfg->writeEntry("filename", filename);
    _cfg->writeEntry("modified", doc->isModified());
		
    QString tempname = kapp->tempSaveName(filename);
    doc->saveDocument(tempname);
  }
}


void KCommander2App::readProperties(KConfig* _cfg)
{
  QString filename = _cfg->readEntry("filename", "");
  bool modified = _cfg->readBoolEntry("modified", false);
  if(modified)
  {
    bool canRecover;
    QString tempname = kapp->checkRecoverFile(filename, canRecover);
  	
    if(canRecover)
    {
      doc->openDocument(tempname);
      doc->setModified();
      QFileInfo info(filename);
      doc->setAbsFilePath(info.absFilePath());
      doc->setTitle(info.fileName());
      QFile::remove(tempname);
    }
  }
  else
  {
    if(!filename.isEmpty())
    {
      doc->openDocument(filename);
    }
  }

  QString caption=kapp->caption();	
  setCaption(caption+": "+doc->getTitle());
}		

bool KCommander2App::queryClose()
{
	return true;
}

bool KCommander2App::queryExit()
{
  saveOptions();
  return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void KCommander2App::slotFileNewWindow()
{
  slotStatusMsg(i18n("Opening a new application window..."));
	
  KCommander2App *new_window= new KCommander2App();
  new_window->show();

  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KCommander2App::slotFileClose()
{
  slotStatusMsg(i18n("Closing file..."));
	
  close();
  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KCommander2App::slotFileQuit()
{
  slotStatusMsg(i18n("Exiting..."));
  saveOptions();
	close();
}

void KCommander2App::slotViewToolBar()
{
  slotStatusMsg(i18n("Toggle the toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
  if( viewMenu->isItemChecked(ID_VIEW_TOOLBAR))
  {
    viewMenu->setItemChecked(ID_VIEW_TOOLBAR, false);
    enableToolBar(KToolBar::Hide);
  }
  else
  {
    viewMenu->setItemChecked(ID_VIEW_TOOLBAR, true);
    enableToolBar(KToolBar::Show);
  }		

  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KCommander2App::slotViewStatusBar()
{
  slotStatusMsg(i18n("Toggle the statusbar..."));
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
  if( viewMenu->isItemChecked(ID_VIEW_STATUSBAR))
  {
    viewMenu->setItemChecked(ID_VIEW_STATUSBAR, false);
    enableStatusBar(KStatusBar::Hide);
  }
  else
  {
    viewMenu->setItemChecked(ID_VIEW_STATUSBAR, true);
    enableStatusBar(KStatusBar::Show);
  }

  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}


void KCommander2App::slotStatusMsg(const QString &text)
{
  statusBar()->changeItem(text, ID_STATUS_MSG);
}


void KCommander2App::slotStatusHelpMsg(const QString &text)
{
  statusBar()->message(text, 2000);
  setCaption(text);
}

void KCommander2App::commandStartMenu(int id_)
{
		if(id_ == ID_MENU_STARTER)
					{
						dlgStartmenu *s = new dlgStartmenu();
						s->exec();
						delete s;
						// Alle Mens von ID_STARTMENU bis ID_STARTMENU+99 lschen
						for(int i=ID_STARTMENU;i< ID_STARTMENU+100;i++)
							if(startMenu->findItem(i))
								startMenu->removeItem(i);
						startMenu->removeItem(ID_MENU_STARTER);
						startMenu->removeItem(ID_MENU_ASSIGNS);
						// jetzt die vorhandenen neuen adden !
						KConfig *config = kapp->config();
						config->setGroup("Startmenu");
						QString t;
						bool flag = true;
						int i=0;
						while(flag)
						{
							t.sprintf("Menutitle%d",i);
							QString titel = config->readEntry(t,"");
							if(titel == "") break;
							startMenu->insertItem(titel,ID_STARTMENU+i);
							i++;
						}
			      startMenu->insertSeparator();
			      startMenu->insertItem( i18n("Change Start Menu..."),ID_MENU_STARTER );
      			startMenu->insertItem( i18n("Edit Path Assigns..."),ID_MENU_ASSIGNS );
					return;	
					}
				if((id_ >= ID_STARTMENU) && (id_ < ID_STARTMENU+100))
					{
							config->setGroup("Startmenu");
							QString s;
							int i = id_ - ID_STARTMENU;
							
							s.sprintf("MenuApp%d",i);
							QString app(config->readEntry(s,""));
							s.sprintf("MenuParam%d",i);
							QString p(config->readEntry(s,""));
							
							KShellProcess proc("bash");
							proc << app;
							
							// Parameter nun noch zerpflcken
							p = p.simplifyWhiteSpace();
							
							while(p.find(" ") != -1)	// solange in schleife bleiben, wei ein space vorhanden
							{					
								int pos = p.find(" "); 					// Stelle mit Space finden
								QString temp(p.left(pos));				// temp wird JETZT bergeben
								p = p.right(p.length()-pos-1);  // der Rest weniger Space bleibt in Param
//								insertParam(temp,&proc);
							}
//							insertParam(p,&proc);
							proc.start(KProcess::DontCare,KProcess::All);
					}
				if(id_ ==	ID_MENU_ASSIGNS)
					{
						dlgEditAssigns *edAss = new dlgEditAssigns();
						edAss->exec();
//						return();
					}
					else
					{
						QString s;
						s.sprintf("Men [%d] unbekannt !!!",id_);
					}
}

void KCommander2App::commandCallback(int id_)
{
  switch (id_)
  {
    case ID_FILE_NEW_WINDOW:
         slotFileNewWindow();
    	 break;

    case ID_FILE_CLOSE:
         slotFileClose();
         break;

    case ID_FILE_QUIT:
         slotFileQuit();
         break;

    case ID_VIEW_TOOLBAR:
         slotViewToolBar();
         break;

    case ID_VIEW_STATUSBAR:
         slotViewStatusBar();
         break;

		case	ID_VIEW_SHOW_SHORT:
					view->makeShortView();
					break;
		case	ID_VIEW_SHOW_LONG:
					view->makeDetailView();
					break;
		case	ID_MENU_SHOW_HIDDEN:
						slotShowHidden();
					break;
		case	ID_MENU_FTPCONNECT:{
						ftpConfigDialog *fs = new ftpConfigDialog(0,0,true);
						fs->exec();
						if(fs->connectionString.length() == 0)
						{
							delete fs;
							break;
						};
						KURL	ftpURL(fs->connectionString + fs->remotePath);
						QString local = fs->localPath;
						view->setURL(ftpURL); // remote path is ok
						if(local == "~")
              local = QDir::homeDirPath();
						delete fs;
					}
					break;
		case	ID_MENU_FTPNEW:{
//						newFTP *fs = new newFTP(this);
//						fs->exec();
//						delete fs;
					}
					break;
		case	ID_MENU_FTPCLOSE:{
						KURL neu("/");
						view->setURL(neu);										
					}
					break;
		case	ID_MENU_SWAPLISTVIEWS:{
						swapViews();
					}
					break;
		case	ID_MENU_FILEATTR:
					{
						 if(view->fileList()->first() == NULL) break;
						 KFileItem *test = view->findByName(view->fileList()->first()->name());
						 KPropertiesDialog *props = new  KPropertiesDialog(test,this,i18n("Properties"),true);
						 props->exec();
					}
					break;
		case	ID_MENU_FORMAT:
					{
						formatMan	*format = new formatMan();
						format->invoke();
					}
					break;
		case	ID_MENU_HELPABOUT:
					{
						aboutwindow *helpwin = new aboutwindow();
						helpwin->exec();
					}
					break;
		case	ID_MENU_PACK:
					{
     				if(view->fileList()->first() == NULL)
     				  break;
  					compress(view->fileList());
					}
					break;
		case	ID_MENU_OPTIONS:
					{
            OptionsDialog *od = new OptionsDialog();
            od->exec();
            delete od;
            // FUX ...config neu einlesen ?? Toolbar, fonts etc etc
            initToolBar();
					}
					break;
		case	ID_MENU_STARTTERM:
					{
						startTerminal();
					}
					break;
		case	ID_MENU_MARKGROUP:
					{
						view->makeSelection();
					}
					break;
		case	ID_MENU_MARKALL:
					{
						view->makeOtherSelection(1);
					}
					break;
		case	ID_MENU_MARKREVERSE:
					{
						view->makeOtherSelection(2);
					}
					break;
		case	ID_MENU_MARKNONE:
					{
						view->makeOtherSelection(3);
					}
					break;
		case	ID_MENU_REMARKGROUP:
					{
						view->makeUnSelection();
					}
					break;
		case ID_MENU_SPLITFILE:
					{
						dlgSplit *split = new dlgSplit(this,view->fileList()->first()->name());
						split->exec();
					}

		case	ID_MENU_SHOW_DRIVES:
					view->showDRIVES();
					break;
		case	ID_MENU_SHOW_CPU:
					view->showCPU();
					break;
		case	ID_MENU_SHOW_MEM:
					view->showMEM();
					break;
		case	ID_MENU_SHOW_MORE:
					break;

    default:
         break;
  }
}

void KCommander2App::toolButtonPressed(int bt)
{
	config->setGroup("ToolButtons");
  QString tmp;
	// look if it is an external or an kc-command
	// first get the index of the pressed button	
	int button = bt-TOOLBUTTON;
	
	// get the KC-Flag
	tmp.sprintf("tb_%d_isKCCommand",button);
	bool kcflag = config->readBoolEntry(tmp);
	// ok, if it is an KCommander internal routine we have to switch
	if(kcflag)
	{
		// it is a internal command, we only need the command-index
	}
	else
	{
  	// for the external, we need the command
  	tmp.sprintf("tb_%d_Command",button);
  	tmp = config->readEntry(tmp,"");
		KShellProcess proc("bash");
		proc << tmp;
		proc.start(KProcess::Block,KProcess::All);
	}
		
}


void KCommander2App::statusCallback(int id_)
{
  switch (id_)
  {
    case ID_FILE_NEW_WINDOW:
         slotStatusHelpMsg(i18n("Opens a new application window"));
         break;

    case ID_FILE_NEW:
         slotStatusHelpMsg(i18n("Creates a new document"));
         break;

    case ID_FILE_OPEN:
         slotStatusHelpMsg(i18n("Opens an existing document"));
         break;

    case ID_FILE_OPEN_RECENT:
         slotStatusHelpMsg(i18n("Opens a recently used file"));
         break;

    case ID_FILE_SAVE:
         slotStatusHelpMsg(i18n("Saves the actual document"));
         break;

    case ID_FILE_SAVE_AS:
         slotStatusHelpMsg(i18n("Saves the actual document as..."));
         break;

    case ID_FILE_CLOSE:
         slotStatusHelpMsg(i18n("Closes the actual document"));
         break;

    case ID_FILE_PRINT:
         slotStatusHelpMsg(i18n("Prints out the actual document"));
         break;

    case ID_FILE_QUIT:
         slotStatusHelpMsg(i18n("Quits the application"));
         break;

    case ID_EDIT_CUT:
         slotStatusHelpMsg(i18n("Cuts the selected section and puts it to the clipboard"));
         break;

    case ID_EDIT_COPY:
         slotStatusHelpMsg(i18n("Copies the selected section to the clipboard"));
         break;

    case ID_EDIT_PASTE:
         slotStatusHelpMsg(i18n("Pastes the clipboard contents to actual position"));
         break;

    case ID_VIEW_TOOLBAR:
         slotStatusHelpMsg(i18n("Enables/disables the toolbar"));
         break;

    case ID_VIEW_STATUSBAR:
         slotStatusHelpMsg(i18n("Enables/disables the statusbar"));
         break;
    case ID_MENU_SHOW_DRIVES:
         slotStatusHelpMsg(i18n("Shows the amount of your used drives"));
         break;
    case ID_MENU_SHOW_CPU:
         slotStatusHelpMsg(i18n("Shows statistics about your CPU"));
         break;
    case ID_MENU_SHOW_MEM:
         slotStatusHelpMsg(i18n("Shows your used memory"));
         break;

    default:
         break;
  }
}

void KCommander2App::slotShowHidden()
{
  slotStatusMsg(i18n("Shows the hidden files..."));
  if( viewMenu->isItemChecked(ID_MENU_SHOW_HIDDEN))
  {
    viewMenu->setItemChecked(ID_MENU_SHOW_HIDDEN, false);
  	view->showHidden(false);
  }
  else
  {
    viewMenu->setItemChecked(ID_MENU_SHOW_HIDDEN, true);
  	view->showHidden(true);
  }
  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KCommander2App::openDocumentFile(const char* _cmdl)
{
  slotStatusMsg(i18n("Opening file..."));

  doc->openDocument(_cmdl);
  slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

void KCommander2App::keyPressEvent(QKeyEvent *e)
{
	if(e->key() == 4096 /*ESCAPE*/)
	  if(view->statusView)
	  {
	    delete view->statusView;
	    view->statusView = 0L;
	  }
	emit keyPress(e);
	e->ignore();
}
void KCommander2App::keyReleaseEvent(QKeyEvent *)
{
}

void KCommander2App::swapViews()
{
	view->swapViews();
}
