/***************************************************************************
                          kcommander2.h  -  description
                             -------------------
    begin                : Sun Sep 17 12:25:22 GMT 2000
    copyright            : (C) 2000 by Rene Mrten / Christian Fricke
    email                : cfricke@codewizards.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCOMMANDER2_H
#define KCOMMANDER2_H

#ifdef HAVE_CONFIG_H
#include <config.h>

#endif
#include <qstrlist.h>
#include <qsplitter.h>
#include <mysplitter.h>

#include <kapp.h>
#include <ktmainwindow.h>
#include <kaccel.h>
#include "filebasisview.h"
#include "dlgfformat.h"
#include "options.h"
//#include <kmailIface.h>
#include <dlgFtpConfig.h>

class KCommander2Doc;
class KCommander2View;

class KCommander2App : public KTMainWindow
{
  Q_OBJECT

  friend class KCommander2View;

  public:
    KCommander2App();
    ~KCommander2App();
	
    void enableCommand(int id_);
    void disableCommand(int id_);
    void addRecentFile(const QString &file);
    void openDocumentFile(const char *_cmdl=0);
    KCommander2Doc *getDocument() const; 	
    void compress(KFileViewItemList *);
		void sendMail();

  protected:
    void saveOptions();
    void readOptions();
    void initKeyAccel();
    void initMenuBar();
    void initToolBar();
    void initStatusBar();
    void initDocument();
    void initView();
    virtual bool queryClose();
    virtual bool queryExit();
    virtual void saveProperties(KConfig *_cfg);
    virtual void readProperties(KConfig *_cfg);

  public slots:
    void commandCallback(int id_);
    void commandStartMenu(int id_);
    void statusCallback(int id_);
    void slotFileNewWindow();
    void slotFileClose();
    void slotFileQuit();
    void slotViewToolBar();
    void slotViewStatusBar();
    void slotShowHidden();
    void slotStatusMsg(const QString &text);
    void slotStatusHelpMsg(const QString &text);
		void toolButtonPressed(int);
	  void keyPressEvent( QKeyEvent *);	
    void keyReleaseEvent(QKeyEvent *);
  private:
    QStrList recentFiles;

    KConfig *config;
    KAccel *keyAccel;
    QPopupMenu *fileMenu;
    QPopupMenu *recentFilesMenu;
    QPopupMenu *editMenu;
    QPopupMenu *markMenu;
    QPopupMenu *commandMenu;
    QPopupMenu *viewMenu;
    QPopupMenu *startMenu;
    QPopupMenu *helpMenu_;
    QPopupMenu *helpMenu2;
    QPopupMenu *systemMenu;
    KCommander2View *view;
    KCommander2Doc *doc;
    QBoxLayout *mainLayout;
    QSplitter *splitView;
    void swapViews();
    void startTerminal();

 signals:	
	void keyPress(QKeyEvent *);
};
 
#endif // KCOMMANDER2_H
