/***************************************************************************
                          kcommander2doc.cpp  -  description
                             -------------------
    begin                : Sun Sep 17 12:25:22 GMT 2000
    copyright            : (C) 2000 by Rene Mrten / Christian Fricke
    email                : cfricke@codewizards.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qdir.h>
#include <qfileinfo.h>
#include <qwidget.h>

// include files for KDE
#include <klocale.h>
#include <kmessagebox.h>

// application specific includes
#include "kcommander2doc.h"
#include "kcommander2.h"
#include "kcommander2view.h"

QList<KCommander2View> *KCommander2Doc::pViewList = 0L;

KCommander2Doc::KCommander2Doc(QWidget *parent, const char *name) : QObject(parent, name)
{
  if(!pViewList)
  {
    pViewList = new QList<KCommander2View>();
  }

  pViewList->setAutoDelete(true);
}

KCommander2Doc::~KCommander2Doc()
{
}

void KCommander2Doc::addView(KCommander2View *view)
{
  pViewList->append(view);
}

void KCommander2Doc::removeView(KCommander2View *view)
{
  pViewList->remove(view);
}

void KCommander2Doc::setAbsFilePath(const QString &filename)
{
  absFilePath=filename;
}

const QString &KCommander2Doc::getAbsFilePath() const
{
  return absFilePath;
}

void KCommander2Doc::setTitle(const QString &_t)
{
  title=_t;
}

const QString &KCommander2Doc::getTitle() const
{
  return title;
}

void KCommander2Doc::slotUpdateAllViews(KCommander2View *sender)
{
  KCommander2View *w;
  if(pViewList)
  {
    for(w=pViewList->first(); w!=0; w=pViewList->next())
    {
      if(w!=sender)
        w->repaint();
    }
  }

}

void KCommander2Doc::closeDocument()
{
  deleteContents();
}

bool KCommander2Doc::newDocument()
{
  /////////////////////////////////////////////////
  // TODO: Add your document initialization code here
  /////////////////////////////////////////////////
  modified=false;
  absFilePath=QDir::homeDirPath();
  return true;
}

bool KCommander2Doc::openDocument(const QString &filename, const char *)
{
  QFileInfo fileInfo(filename);
  title=fileInfo.fileName();
  absFilePath=fileInfo.absFilePath();	
  /////////////////////////////////////////////////
  // TODO: Add your document opening code here
  /////////////////////////////////////////////////
  modified=false;
  return true;
}

bool KCommander2Doc::saveDocument(const QString &, const char *)
{
  /////////////////////////////////////////////////
  // TODO: Add your document saving code here
  /////////////////////////////////////////////////

  modified=false;
  return true;
}

void KCommander2Doc::deleteContents()
{
  /////////////////////////////////////////////////
  // TODO: Add implementation to delete the document contents
  /////////////////////////////////////////////////

}
