/***************************************************************************
                          kfileicondrag.cpp  -  description
                             -------------------
    begin                : Sun Feb 4 2001
    copyright            : (C) 2001 by Rene Mrten & Christian Fricke
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          kfileicondrag.cpp  -  description
                             -------------------
    begin                : Sun Jul 23 2000
    copyright            : (C) 2000 by Bjrn Sahlstrm
    email                : bjorn.sahlstrom@mail.bip.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kfileicondrag.h"

//-----------------------------------------------
KFileIconDrag::KFileIconDrag( QWidget * dragSource, const char* name )
    : QIconDrag( dragSource, name )
{
}
//-----------------------------------------------
const char* KFileIconDrag::format( int i ) const {
	if ( i == 0 )
		return "application/x-qiconlist";
	else if ( i == 1 )
		return "text/uri-list";
	else
		return 0;
}
//-----------------------------------------------
QByteArray KFileIconDrag::encodedData( const char* mime ) const {
	QByteArray a;
	if ( QString( mime ) == "application/x-qiconlist" ) {
		a = QIconDrag::encodedData( mime );
	}
	else if ( QString( mime ) == "text/uri-list" ) {
		QString s = urls.join( "\r\n" );
		a.resize( s.length() );
		memcpy( a.data(), s.latin1(), s.length() );
	}
	return a;
}
//-----------------------------------------------
bool KFileIconDrag::canDecode( QMimeSource* e ) {
	return e->provides( "application/x-qiconlist" ) ||
				e->provides( "text/uri-list" );
}
//-----------------------------------------------
void KFileIconDrag::append( const QIconDragItem &item, const QRect &pr,
			     const QRect &tr, const QString &url ) {
	QIconDrag::append( item, pr, tr );
	urls << url;
}
//-----------------------------------------------
