/***************************************************************************
                          kfileicondrag.h  -  description
                             -------------------
    begin                : Sun Jul 23 2000
    copyright            : (C) 2000 by Bjrn Sahlstrm
    email                : bjorn.sahlstrom@mail.bip.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KFILEICONDRAG_H
#define KFILEICONDRAG_H

//////////////////////////////////////////////////////
// Qt specific includes
#include <qiconview.h>

	/**
	*The KFileIconDrag class is the drag object which is used for moving items in the iconview
	*@author Bjrn Sahlstrm
	*/

class KFileIconDrag : public QIconDrag {
    Q_OBJECT
public:
    /** */
    KFileIconDrag( QWidget * dragSource, const char* name = 0 );
    /** */
    ~KFileIconDrag(){}
    /** */
    const char* format( int i ) const;
    /**
    *Returns the encoded data of the drag object if mime is application/x-qiconlist or text/uri-list.
    */
    QByteArray encodedData( const char* mime ) const;
    /**
    *Returns TRUE if e can be decoded by the KBearFileIconDrag, else FALSE.
    */
    static bool canDecode( QMimeSource* e );
    /**
    *Appends an icon drag item which should be stored in this dragobject and the geometry of it.
    * It also appends the url that the icon represents.
	*@see QIconDrag
	*/
    void append( const QIconDragItem &item, const QRect &pr, const QRect &tr, const QString &url );

private:
    QStringList urls;
};

#endif
