/***************************************************************************
                          ktar2.cpp  -  description
                             -------------------
    begin                : Sun Feb 4 2001
    copyright            : (C) 2001 by Rene Mrten & Christian Fricke
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          KTar2.cpp  -  description
                             -------------------
    begin                : Thu Oct 14 1999
    copyright            : (C) 1999 by Rene Mrten, Christian Fricke
    email                : @-Mail to: delta_x@LinuxCoding.DE
                                      cfricke@LinuxCoding.DE
****************************************************************************/
#include "ktar2.h"
#include <qapplication.h>
#include <qtextstream.h>
#include <klocale.h>
#include <kfileview.h>

KTar2::KTar2(KFileViewItemList *list , const char *archivename,QWidget *parent, const char *name) : QDialog(parent,name,true)
{
//*****************************************************************************************
	// Optik !!
	tmp = list;
	arc = archivename;
	ende = false;
	resize(300,120);
	setMinimumSize(300,120);
	setMaximumSize(300,120);
	QLabel *l;
	l = new QLabel("Info:",this);
	l->setGeometry(10,30,50,20);
	dateiname = new QLabel(i18n("File :"),this);
	dateiname->setGeometry(60,30,230,20);
	QString s;
//	Packer = optionen::askPacker();
	Packer = "tar";
	s.sprintf(QString("KTar2 ") + i18n("compress with ") + Packer);
 	setCaption(s);
	p1 = new KProgress(0,100,0,Horizontal,this);
	p1->setGeometry(10,55,280,20);

	startTimer(500);			
}

KTar2::~KTar2(){
	delete dateiname;
}


void	KTar2::timerEvent(QTimerEvent *)
{
	killTimers();
	doIt(tmp,arc);
}
void KTar2::doIt(KFileViewItemList *list, const char *archivename)
{
		int files = 0;				// filecounter = 0
		int percent=0;
		QString s,a;

		QDir::setCurrent(list->first()->url().directory());
		a = list->first()->url().directory();
		a += "/";
		a += archivename;
		s = list->first()->url().fileName();//urlString();
		files = list->count();
		p1->setRange(0,files);
		percent = 0;
		kapp->processEvents();
		
		dateiname->setText(s);
		nextFile = false;			// muss warten, solange bis TAR Ergebnis zurckgibt (false or true, togal!)
		KShellProcess proc("bash");
		proc << "tar";
		proc << "cf";                        // neues Archiv erstellen !
		proc << a+".tar";	// Archivename
		proc << s;														// Dateiname
		QApplication::connect(&proc, SIGNAL(processExited(KProcess *)),this, SLOT(slotExamine()));
		QApplication::connect(&proc, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(receivedStdout(KProcess *, char *, int)));
		QApplication::connect(&proc, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(receivedStderr(KProcess *, char *, int)));
		proc.start(KProcess::Block,KProcess::All);
		p1->setValue(percent++);
		
		while(!nextFile)
			kapp->processEvents();	// solange in Schleife bleiben, wie nextFile = false
		// ersten Filenamen loeschen weil gepackt
			list->removeFirst();

	  QListIterator<KFileViewItem> kit ( *list );
	  kit.toFirst();
	  for( ; kit.current(); ++kit )
  	{
			s = (*kit)->url().fileName();
			kapp->processEvents();
			QString ss=s;
			if(ss.length() >30)
			{
				ss = ss.left(15) + "...." + ss.right(15);
			}
			dateiname->setText(ss);
			KShellProcess proc("bash");
			proc << "tar";
			proc << "rf";
			proc << a +".tar";	// Archivename
			proc << s;						// Dateiname
			
			nextFile = false;					// das er nicht gleich noch weiter macht
			QApplication::connect(&proc, SIGNAL(processExited(KProcess *)),this, SLOT(slotExamine()));
			QApplication::connect(&proc, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(receivedStdout(KProcess *, char *, int)));
			QApplication::connect(&proc, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(receivedStderr(KProcess *, char *, int)));
			proc.start(KProcess::Block,KProcess::All);
			while(!nextFile)
				kapp->processEvents();	// solange in Schleife bleiben, wie nextFile = false
			p1->setValue(percent++);
			if(ende == true)	// ende wird nur TRUE, wenn Fenster whrend des Packens geschlosssen wird
			{
				return;
			}
 		}
		ende = true;
			
			p1->setValue(p1->maxValue());
			KShellProcess proc1("bash");
			proc1 << "gzip";
			proc1 << a +".tar";	// Archivename
			QApplication::connect(&proc1, SIGNAL(processExited(KProcess *)),this, SLOT(slotExamine()));
			QApplication::connect(&proc1, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(receivedStdout(KProcess *, char *, int)));
			QApplication::connect(&proc1, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(receivedStderr(KProcess *, char *, int)));
			proc1.start(KProcess::Block,KProcess::All);
		
		close();
}


void KTar2::slotExamine()
{
//	QMessageBox::critical ( (QWidget *)this, "KTar2", "prog zu Ende", 0, 0 );
	nextFile = true;
}
void KTar2::receivedStdout(KProcess *, char *, int )
{
	ready = true;
}
void KTar2::receivedStderr(KProcess *, char *buffer, int buflen)
{
	QString s = buffer;
	s = s.left(buflen);
	QMessageBox::critical ( (QWidget *)this, "KTar2", s, 0, 0 );
	killTimers();
	ende = true;
	nextFile = true;
	close();
}
void KTar2::closeEvent ( QCloseEvent *e)
{
  if(!ende)
  {
		int i = QMessageBox::information ( this, i18n("Cancel ?"), i18n("Break This Process ?"), QMessageBox::Yes, QMessageBox::No);
		if(i == QMessageBox::Yes)
		{
			ende = true;
			e->accept();
		}
	}
	else
		e->accept();
}
