#include "mailer.h"
#include <qfile.h>
#include <qdir.h>
#include <klocale.h>

#define CRLF 0x0D0A

#include <qtextstream.h>

Mailer::Mailer(QString adr, QString fpath,QString fname,QWidget *parent, const char *name) : QWidget(parent, name)
{
	fileName = fname;
	filePath = fpath;
	address = adr;
	// neuer Socket
	CONNECTED = false;
//	SESSION = SMTP;
	mySocket = new QSocket();
   SENT = true;
  written = 0;
  percent = 0;
  fsize = 0;
	startTimer(100);
}

Mailer::~Mailer()
{
}

void Mailer::timerEvent(QTimerEvent *e)
{
	killTimers();
again:
	e = 0;
	config=kapp->config();
  config->setGroup("MailConfig");
  Username = config->readEntry("POPNAME","");
  if(Username.length() == 0)
  {
    // hier das Optionsmenu ffnen fr EMailconfig
    OptionsDialog *od = new OptionsDialog();
    od->exec();
    delete od;
    goto again;
  }
  Pop3Server = config->readEntry("POP3","");
  if(Pop3Server.length() == 0)
  {
    // hier das Optionsmenu ffnen fr EMailconfig
    OptionsDialog *od = new OptionsDialog();
    od->exec();
    delete od;
    goto again;
  }
  Userpassword = config->readEntry("POPPASS");
  if(Userpassword.length() == 0)
  {
    // hier das Optionsmenu ffnen fr EMailconfig
    OptionsDialog *od = new OptionsDialog();
    od->exec();
    delete od;
    goto again;
  }
	
	connect(mySocket,SIGNAL(connected()),SLOT(connectionOK()));
	connect(mySocket,SIGNAL(connectionClosed()),SLOT(connectionClosed()));
	connect(mySocket,SIGNAL(bytesWritten(int)),SLOT(connectionWrote(int)));
	connect(mySocket,SIGNAL(error(int)),SLOT(error(int)));


  bool popFirst = config->readBoolEntry("POPFIRST",false);
  // if we should connect first to pop3 server, we do it...
  if(popFirst)
  {
        // first connect to POP3
       	mySocket->connectToHost(Pop3Server,110); // spter in die config einbauen !!
      	CONNECTED = false;
      	while(!CONNECTED)
      		kapp->processEvents();
      	if(!waitForData())
      		return;	// Fehler !!
        send(QString("USER ") + Username);
      	if(!waitForData())
      		return;	// Fehler !!
        send(QString("PASS ") + Userpassword);
      	if(!waitForData())
      		return;	// Fehler !!
        send(QString("QUIT"));
      	if(!waitForData())
      		return;	// Fehler !!
  }

	// OK, after pop3 connection we can send our email

  Username = "KCommander<" + Username + ">";
	QFile file("/tmp/.kcmail");
	KShellProcess prog("bash");
	prog << "mimencode" << filePath << "-o" << file.name();
	prog.start(KProcess::Block,KProcess::All);
	
	QString smtp(config->readEntry("SMTP",""));
	if(smtp == "")
	{
	  // hier config ffnen
	  return;
	}
	//	Zuerst am SMTP anmelden
	// Die auskommentierten Codezeilen sind noch dazu da, das falls ein Fehler auftritt diesen abzufangen !!!!!!!!!
	
//	
	CONNECTED = false;
	mySocket->connectToHost(smtp,25); // spter in die config einbauen !!
	while(!CONNECTED)
		kapp->processEvents();
	if(!waitForData())
		return;	// Fehler !!
	send(QString("MAIL FROM:") + Username);
	if(!waitForData())
		return;	// Fehler !!
	
	send(QString("RCPT TO:") + address);
	if(!waitForData())
		return;	// Fehler !!

	send(QString("DATA"));
	if(!waitForData())
		return;	// Fehler !!
	send(QString("Content-Type: multipart/mixed;"));
	send(QString(" boundary=\"------------0A26F574DD17247FC05CCD7C\"")); // Achtung Leerzeichen needed !!
	send(QString("MIME-Version: 1.0"));
	
//	send(QString("From: ")+ Username);
	send(QString("From: KCommander2"));
	send(QString("To: ")  + address);

	
	
	// Subject = filename without path
	while(filePath.find("/") != -1)
	{
	  filePath = filePath.right(filePath.length()-filePath.find("/")-1);
	  kapp->processEvents();
	}
	
	send(QString("Subject: <") + filePath + ">\n");
	
	send(QString("--------------0A26F574DD17247FC05CCD7C"));
	send(QString("Content-Type: text/plain; charset=us-ascii"));
	send(QString("Content-Transfer-Encoding: 8bit\n\n"));
	send(QString(".-----------------------------------------( written by R. Mrten & Ch. Fricke )----------"));
	send(QString("| This file was sent by a friend using KCommander2."));
	send(QString("| Take a look at http://www.kcommander.org and let us know if all ok with our KCommander."));
	send(QString("`----------------------------------------------------------------------------------------"));
	send(QString("Here comes the attachement:\n"));
	send(QString("--------------0A26F574DD17247FC05CCD7C"));  // jeder Teil der Mail ist mit diesem Teil abzuschliessen,
	// so das man nacher auch mehrere Files senden kann !!!!!

//------------------------------------------------------------------------------------------------
// Jetzt kommt der wichtigste Teil der Message !!   Ein File ist zu senden :)
//------------------------------------------------------------------------------------------------		
	send(QString("Content-Type: application/octet-stream;")+QString(" name=\"")+fileName+QString("\""));
	send(QString("Content-Transfer-Encoding: base64"));
	send(QString("Content-Disposition: attachment;")+QString(" filename=\"")+fileName+QString("\""));
	send("");
	
	
	writeFile(file.name());   // hier muss irgendwie gewartet werden bis der fertig ist mit Senden :)
		
	send(QString("--------------0A26F574DD17247FC05CCD7C--\n")); // Das ist der Abschluss der Mail !!!!  Achte auf die -- Zeichen am Ende :)
	send(QString("."));
	if(!waitForData())
		return;	// Fehler !!
	send(QString("QUIT"));
	if(!waitForData())
		return;	// Fehler !!
	file.remove();
}

void Mailer::connectionOK()
{
	CONNECTED = true;
}

bool Mailer::waitForData()
{
	int b=0;
	char 	*block;
	while((b=mySocket->bytesAvailable())==0)
	{
		kapp->processEvents();
	
	}
	block = (char *)malloc(b);
	mySocket->readBlock( block, b );
	QString buffer(block); buffer = buffer.left(b-1);
	free(block);
  debug("Empfange : " + buffer);
  if(buffer.left(3) == "+OK")
    return true;
  if(buffer.left(4) == "-ERR")
    return false;
  if(buffer.left(3) == "451")	
  {
    return false;
  }
  if(buffer.left(3) == "550" || buffer.left(3) == "552")
  {
    // wrong email address
    return false;
  }
	
	 return true;
}


void Mailer::send(const char *ss)
{
	QString s(ss);
	s += CRLF;
	debug("Sende     : " + QString(ss));
	int result = mySocket->writeBlock(s, s.length());
	result = 0;
}

void Mailer::connectionClosed()
{
	CONNECTED = false;
	close();
}
void Mailer::error(int err)
{
	QString s; s.sprintf("Error: %d",err);
	CONNECTED = false;
}

void Mailer::connectionWrote(int n)
{
  if(fsize != 0)
  {
     percent = 100 * written / fsize;
     QString p;
     p.sprintf("%d %% was sent",percent);
     emit changeStatus(p);
     written += n;
  }
  else
     emit changeStatus("Waiting for Connection...");

}

void Mailer::writeFile(QString what)
{
  QFile f(what);
  fsize = f.size();
  if(fsize ==0)
    fsize = 1;  //division 0 error !
  if ( f.open(IO_ReadOnly) )
  {
    QTextStream t( &f );        // use a text stream
    QString s;
    while ( !t.eof() )
    { // until end of file...
      s = t.readLine();       // line of text excluding '\n'
      send(QString(s));
      kapp->processEvents();
    }
    f.close();
  }
}

