/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sun Sep 17 12:25:22 GMT 2000
    copyright            : (C) 2000 by Rene Mrten / Christian Fricke
    email                : cfricke@codewizards.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include "kcommander2.h"

#include "statics.h"

static const char *description =
	I18N_NOOP("KCommander2");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  // INSERT YOUR COMMANDLINE OPTIONS HERE
  { "+[-l]", I18N_NOOP("Directory for the left View"), 0 },
  { "+[-r]", I18N_NOOP("Directory for the right View"), 0 },
  { 0, 0, 0 }
};

int main(int argc, char *argv[])
{

	KAboutData aboutData( "kcommander2", I18N_NOOP("KCommander2"),
		VERSION,description, KAboutData::License_GPL,
		"(c) 2000, Rene Mrten / Christian Fricke");
	aboutData.addAuthor("Rene Mrten / Christian Fricke",0, "cfricke@kcommander.org");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KCommander2App);
  }
  else 
  {
    KCommander2App *kcommander2 = new KCommander2App();

    kcommander2->show();

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		
		if (args->count())
		{
        kcommander2->openDocumentFile(args->arg(0));
		}
		else
		{
		  kcommander2->openDocumentFile();
		}
		args->clear();
  }

  return app.exec();
}  
