/***************************************************************************
                          mainslots.h  -  is a part of kcommander2view
                             -------------------
    begin                : Sun Sep 17 12:25:22 GMT 2000
    copyright            : (C) 2000 by Rene Mrten / Christian Fricke
    email                : cfricke@codewizards.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kcommander2view.h"
#include "kcommander2.h"
#include "inputbox.h"
#include <kapp.h>
#include "ktar2.h"
#include <ktar.h>
#include <klibloader.h>
#include <kparts/factory.h>
#include <kparts/part.h>


void KCommander2View::fillDriveAssigns(QPopupMenu *menu)
{
	KConfig *config = kapp->config();
	config->setGroup("Assignments");
	QString s;
	QString titel;
	QString titel2;
	for(int i=0; i<26;i++)
	{
		s.sprintf("DriveAssign%c",i+'A');
		titel = config->readEntry(s,"");
		titel2.sprintf("&%c - ",i+'A');
		titel = titel2 + titel;
		menu->insertItem(titel,i);
	}
}
	
void KCommander2View::drivePopupActivated ( int akey )
{
	KConfig *config = kapp->config();
	config->setGroup("Assignments");
	QString path;
	QString titel2;
   QString s;
   s.sprintf("DriveAssign%c", akey + 'A');
	path = config->readEntry(s,"");
   if(path == "")
      return;
   path += "/";
   s = sender()->name();
   if(s == "1")
   {
		viewer3->setURL(KURL(path),true);
   }
   else
   {
		viewer1->setURL(KURL(path),true);
   }
}

void KCommander2View::swapViews()
{
	QString tmp,tmp1;
	tmp = viewer1->currentDir();
	tmp1 = viewer3->currentDir();
	viewer1->setURL(KURL(tmp1));
	viewer3->setURL(KURL(tmp));
}

void KCommander2App::compress(KFileViewItemList *list)
{
    InputBox *ipb = new InputBox(this,i18n("Set filename"));
    ipb->exec();
    QString fileName = ipb->returnInput();
    delete(ipb);
    KTar2 *tarFile2 = new KTar2(list,fileName);
    tarFile2->exec();
}
//	Arno !!!!!!/////////////////////////////////////////////////////////////////////
void KCommander2App::startTerminal()
{
  KLibFactory *m_factory;
  m_factory = KLibLoader::self()->factory("libkonsolepart");
  QObject *obj;
  obj = static_cast<KParts::Factory *>(m_factory)->createPart();
  KParts::ReadOnlyPart *test = static_cast<KParts::ReadOnlyPart *>(obj);
  test->widget()->setCaption(i18n("KCommander2-Terminal"));
  test->widget()->show();
}
//////////////////////////////////////////////////////////////////////////////////
void KCommander2View::commandoInserted(const QString &string)
{
//	commandoBox->changeItem("",commandoBox->currentItem());
	if (string == "")
	  return; // weil sinnlos wenn leer !!!
	
	
	if(commandoLabel->text().find("file") == -1)
	  return; //Falls FTP oder tar !!??
	QString labelTmp(commandoLabel->text());
	labelTmp = labelTmp.right(labelTmp.length()-5); // file:  rausfiltern
	QDir::setCurrent(labelTmp);         // und aktuelle Dir setzen
		
	QString tmp(string);
	if (tmp.find("cd") != -1)
	{
		tmp = tmp.right(tmp.length()-3);
		KURL Url(tmp);
		setURL(Url);
		QDir::setCurrent(Url.url());	
	}
	else
	{
	KShellProcess proc("bash");
	proc << string;
	proc.start(KProcess::DontCare,KProcess::NoCommunication);
	}
}

void KCommander2View::makeSelection()
{
			InputBox * ip = new InputBox(this,"input extension","*.*");
			ip->exec();
			temp->setSelection(ip->me->text());
}

void KCommander2View::makeUnSelection()
{
			InputBox * ip = new InputBox(this,"input extension","*.*");
			ip->exec();
			temp->setSelection(ip->me->text());
}

void KCommander2View::makeOtherSelection(int what)
{
	switch (what)
	{
  	case 1:
			{
				temp->setSelectionAll();
			}	
			break;
  	case 2:
			{
				temp->setSelectionInvert();
			}	
			break;
  	case 3:
			{
				temp->setSelectionNone();
			}	
			break;
		default: break;
	}
}
