/***************************************************************************
                          options.cpp  -  description
                             -------------------
    begin                : Sun Feb 4 2001
    copyright            : (C) 2001 by Rene Mrten & Christian Fricke
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "options.h"
#include <qheader.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <klocale.h>
#include <kapp.h>
#include <kstddirs.h>
#include <qfile.h>


OptionsDialog::OptionsDialog( QWidget* parent,  const char* name, bool , WFlags fl )
    : QDialog( parent, name, true, fl )
{
	  setName(tr("KCommander Options" ));
    setMinimumSize( 600, 454 );
    setMaximumSize( 600, 454 );
    setCaption( tr( "KCommander Options"  ) );

    PushButton1 = new QPushButton( this, "PushButton1" );
    PushButton1->setGeometry( QRect( 321, 420, 90, 25 ) ); 
    PushButton1->setText( tr( "Close"  ) );
    connect(PushButton1,SIGNAL(clicked()),SLOT(accept()));

    ListView1 = new QListView( this, "ListView1" );
    ListView1->addColumn( tr( " " ) );
    ListView1->header()->setClickEnabled( FALSE, ListView1->header()->count() - 1 );
    ListView1->header()->setResizeEnabled( FALSE, ListView1->header()->count() - 1 );

    QListViewItem * item = 0L;// = new QListViewItem( ListView1, 0 );

    KIconLoader *kil = new KIconLoader();
    QString temp;


    item = new QListViewItem( ListView1, item );
    item->setText( 0, tr( "  Fonts" ) );
    item->setPixmap(0,kil->loadIcon("fonts",KIcon::Desktop));

//    item = new QListViewItem( ListView1, item );
//    item->setText( 0, tr( "  FTP-Server" ) );
//    item->setPixmap(0,kil->loadIcon("ftp",KIcon::Desktop));

    item = new QListViewItem( ListView1, item );
    item->setText( 0, tr( "  Mail Configuration" ) );
    item->setPixmap(0,kil->loadIcon("mail_generic",KIcon::Desktop));

    item = new QListViewItem( ListView1, item );
    item->setText( 0, tr( "  Security Questions" ) );
    item->setPixmap(0,kil->loadIcon("stop",KIcon::Desktop));

    item = new QListViewItem( ListView1, item );
    item->setText( 0, tr( "  Toolbuttons" ) );
    item->setPixmap(0,kil->loadIcon("configure",KIcon::Desktop));

    ListView1->setGeometry( QRect( 10, 0, 180, 441 ) );
    ListView1->setAllColumnsShowFocus( FALSE );
    connect(ListView1,SIGNAL(clicked(QListViewItem * )),SLOT(itemClicked(QListViewItem *)));
	  wz = new wizzard(this);
	  wz->setGeometry(200,25,390,390);
}

/*  
 *  Destroys the object and frees any allocated resources
 */
OptionsDialog::~OptionsDialog()
{
    // no need to delete child widgets, Qt does it all for us
}
void OptionsDialog::timerEvent(QTimerEvent *)
{
}
void OptionsDialog::itemClicked(QListViewItem *item)
{
  if(!item)
    return;
  QString s = item->text(0);
//  if(s == tr("  FTP-Server"))
//    wz->setPage(0);
  if(s == tr("  Fonts"))
    wz->setPage(1);
  if(s == tr("  Mail Configuration"))
    wz->setPage(2);
  if(s == tr("  Security Questions"))
    wz->setPage(3);
  if(s == tr("  Toolbuttons"))
    wz->setPage(4);
}
	
	
wizzard::wizzard(QWidget *parent, const char *name)
    : QWidget( parent, name)
{
  actuellButton = 0;
  tabs[0] = 0L; // wichtig ! drinne lassen
  pageNumber = 0;
  for(int i=0;i<10;i++)
  {
    tabs[i] = new QWidget(this);
  }
  show();
  initTabs();
}
wizzard::~wizzard()
{
}
void wizzard::setPage(int page)
{
  if(page < 10)
    pageNumber = page;
  else
    return;
  for(int i=0;i<10;i++)
  {
    tabs[i]->setGeometry(2,2,width()-4,height()-4);
    if(i == pageNumber)
      tabs[i]->show();
    else
      tabs[i]->hide();
  }
}
void wizzard::paintEvent(QPaintEvent *)
{
  QPainter p(this);
  p.setPen(white);
  p.drawLine(0,0,389,0);
  p.drawLine(0,1,389,1);
  p.drawLine(0,0,0,389);
  p.drawLine(1,0,1,389);
  p.setPen(black);
  p.drawLine(1,389,389,389);
  p.drawLine(2,388,389,388);
  p.drawLine(389,389,389,1);
  p.drawLine(388,389,388,2);
}
void wizzard::show()
{
  QWidget::show();
  if(!tabs[0])
    return;
  setPage(0);
}

void wizzard::initTabs()
{

  config = kapp->config();
  config->setGroup("MailConfig");

// definiert Labelnr.                                 definiert Tabnummer
  label[popServer] =    new QLabel("Popserver (POP3):", tabs[MailConfig]);
  label[mailServer] =   new QLabel("Mailserver (SMTP):",tabs[MailConfig]);
  label[popName] =      new QLabel("POP-Username:",     tabs[MailConfig]);
  label[popPassword] =  new QLabel("POP-Password:",     tabs[MailConfig]);

  popfirstBox = new QCheckBox("first Check POP3 server ?",tabs[MailConfig]);
  popfirstBox->setGeometry(5,125,220,25);


  label[popServer]->  setGeometry(5,5,120,25);
  label[mailServer]-> setGeometry(5,35,120,25);
  label[popName]->    setGeometry(5,65,120,25);
  label[popPassword]->setGeometry(5,95,120,25);

  edit[popServer] =    new QLineEdit(tabs[MailConfig],"0");
  edit[mailServer] =   new QLineEdit(tabs[MailConfig],"1");
  edit[popName] =      new QLineEdit(tabs[MailConfig],"2");
  edit[popPassword] =  new QLineEdit(tabs[MailConfig],"3");


  QString s;

  bool i = config->readBoolEntry("POPFIRST",false);
  if(!i)
    popfirstBox->setChecked(false);
  else
    popfirstBox->setChecked(true);

  // get config entry
  s = config->readEntry("POP3","<pop3-server>");
	
	// if config not exist,
	if(s == "<pop3-server>")
  {
    QString temp = getMailConfig("host");
    if(temp != "")
    {
      s = temp;
      config->writeEntry("POP3",s);
    }
  }
  edit[popServer]->setText(s);

  s = config->readEntry("SMTP","<smtp-server>");
	if(s == "<smtp-server>")
  {
    // looking in KMail-Config-files
    QString temp = getMailConfig("Smtp Host");
    if(temp != "")
    {
      s = temp;
      config->writeEntry("SMTP",s);
    }
  }
  edit[mailServer]->setText(s);



  s = config->readEntry("POPNAME","<pop3-username>");
	if(s == "<pop3-username>")
  {
    // looking in KMail-Config-files
    QString temp = getMailConfig("login");
    if(temp != "")
    {
      s = temp;
      config->writeEntry("POPNAME",s);
    }
  }
  edit[popName]->setText(s);

  s = config->readEntry("POPPASS","<pop-password>");
	if(s == "<pop-password>")
  {
    // looking in KMail-Config-files
    QString temp = getMailConfig("passwd");
    if(temp != "")
    {
      s = encryptStr(temp);
      debug("Password= " + s);
      config->writeEntry("POPPASS",s);
    }
  }
//  config->writeEntry("POPPASS",s);
  edit[popPassword]->setText(s);

  edit[popServer]->  setGeometry(130,5,250,25);
  edit[mailServer]-> setGeometry(130,35,250,25);
  edit[popName]->    setGeometry(130,65,250,25);
  edit[popPassword]->setGeometry(130,95,250,25);
  edit[popPassword]->setEchoMode(QLineEdit::Password);

  connect(edit[popServer],SIGNAL(textChanged(const QString &)),SLOT(mailCfgChanged(const QString &)));
  connect(edit[mailServer],SIGNAL(textChanged(const QString &)),SLOT(mailCfgChanged(const QString &)));
  connect(edit[popName],SIGNAL(textChanged(const QString &)),SLOT(mailCfgChanged(const QString &)));
  connect(edit[popPassword],SIGNAL(textChanged(const QString &)),SLOT(mailCfgChanged(const QString &)));
  connect(popfirstBox,SIGNAL(stateChanged(int)),SLOT(slotPopFirstPressed(int)));


  label[fontListview] = new QLabel("Font Listview", tabs[FontConfig]);
  label[fontButtons] =  new QLabel("Font Buttons",  tabs[FontConfig]);
  label[fontViewer] =   new QLabel("Font Textview", tabs[FontConfig]);

  label[fontListview]->setGeometry(5,5,120,25);
  label[fontButtons]-> setGeometry(5,35,120,25);
  label[fontViewer]->  setGeometry(5,65,120,25);

    QFont f,deff;
    deff.setPointSize(12);
  label[fontDemo1] = new QLabel("Examplefont 123", tabs[FontConfig]);
  label[fontDemo2] = new QLabel("Examplefont 123", tabs[FontConfig]);
  label[fontDemo3] = new QLabel("Examplefont 123", tabs[FontConfig]);

  label[fontDemo1]->setGeometry(135,5,220,25);
  label[fontDemo2]-> setGeometry(135,35,220,25);
  label[fontDemo3]->  setGeometry(135,65,220,25);

  config->setGroup("FontConfig");
  f = config->readFontEntry("Font_0",&deff);
  label[fontDemo1]->setFont(f);
  f = config->readFontEntry("Font_1",&deff);
  label[fontDemo2]->setFont(f);
  f = config->readFontEntry("Font_2",&deff);
  label[fontDemo3]->setFont(f);

  button[fontBt1] = new QPushButton("...",tabs[FontConfig],"0");
  button[fontBt2] = new QPushButton("...",tabs[FontConfig],"1");
  button[fontBt3] = new QPushButton("...",tabs[FontConfig],"2");


  button[fontBt1]->setGeometry(340,5,25,25);
  button[fontBt2]->setGeometry(340,35,25,25);
  button[fontBt3]->setGeometry(340,65,25,25);

  connect(button[fontBt1],SIGNAL(clicked()),SLOT(fontDialog()));
  connect(button[fontBt2],SIGNAL(clicked()),SLOT(fontDialog()));
  connect(button[fontBt3],SIGNAL(clicked()),SLOT(fontDialog()));

  check[checkDelete] =    new QCheckBox("Ask if: Deleting files",tabs[SecureConfig],"0");
  check[checkOverwrite] = new QCheckBox("Ask if: Overwriting files",tabs[SecureConfig],"1");
  check[checkCopying] =   new QCheckBox("Ask if: Copying Files",tabs[SecureConfig],"2");
  check[checkQuit] =      new QCheckBox("Ask if: Exiting KCommander",tabs[SecureConfig],"3");

  check[checkDelete]->setGeometry(		5,5, 225,25);
  check[checkOverwrite]->setGeometry(	5,35,225,25);
  check[checkCopying]->setGeometry(		5,65,225,25);
  check[checkQuit]->setGeometry(			5,95,225,25);

  connect(check[checkDelete],SIGNAL(stateChanged(int)),SLOT(checkboxChanged(int)));
  connect(check[checkOverwrite],SIGNAL(stateChanged(int)),SLOT(checkboxChanged(int)));
  connect(check[checkCopying],SIGNAL(stateChanged(int)),SLOT(checkboxChanged(int)));
  connect(check[checkQuit],SIGNAL(stateChanged(int)),SLOT(checkboxChanged(int)));

	// GUI fr Toolbuttonconfig
	QListBox *lb = new QListBox(tabs[TbConfig]);
	lb->setGeometry(5,5,150,100);
  for(int i=0;i<20;i++)
  {
  	QString s;
  	s.sprintf("Button %d",i+1);
  	lb->insertItem(s);
  }
  connect(lb,SIGNAL(highlighted(int)),SLOT(toolbuttonSelected(int)));

  iconButton = new QPushButton(tabs[TbConfig]);
  iconButton->setGeometry(170,25,35,35);
  connect(iconButton,SIGNAL(clicked()),SLOT(openIconDlg()));


  buttonLabel = new QLabel(tr("button icon"),tabs[TbConfig]);
  buttonLabel->setGeometry(210,30,200,25);
	
	visibleBox = new QCheckBox(tr("toolbutton is visible"),tabs[TbConfig]);
	visibleBox->setGeometry(5,120,200,25);
  connect(visibleBox,SIGNAL(stateChanged(int)),SLOT(saveVisible(int)));

	// if the following command is a internal command then we hide the lineedit and show the listbox
	kcommanderBox = new QCheckBox(tr("KCommander command"),tabs[TbConfig]);
	kcommanderBox->setGeometry(5,150,200,25);
  connect(kcommanderBox,SIGNAL(stateChanged(int)),SLOT(kcommandChanged(int)));

  externCommand = new QLineEdit(tabs[TbConfig]);
	externCommand->setGeometry(5,180,200,25);
	connect(externCommand,SIGNAL(textChanged(const QString &)),SLOT(commandChanged(const QString &)));
	//on the same place i set the QComboBox
	kcommanderCommands = new QComboBox(tabs[TbConfig]);
	kcommanderCommands->setGeometry(5,180,200,25);
	kcommanderCommands->hide();
	connect(kcommanderCommands,SIGNAL(activated(int)),SLOT(saveKCindex(int)));
	
	
	// to change/update:
	// all internal kcommandercommands
	int index = 0;
	kcommanderCommands->insertItem(tr("compress"),index++);
	kcommanderCommands->insertItem(tr("uncompress"),index++);
	kcommanderCommands->insertItem(tr("send as mail"),index++);
	kcommanderCommands->insertItem(tr("print"),index++);
	kcommanderCommands->insertItem(tr("quit"),index++);
	kcommanderCommands->insertItem(tr("read homedir"),index++);
	kcommanderCommands->insertItem(tr("read Windows Network"),index++);
	kcommanderCommands->insertItem(tr("options"),index++);

	
	QLabel *l = new QLabel(tr("Tooltip for the button"),tabs[TbConfig]);
	l->setGeometry(5,210,375,25);
	commandToolTip= new QLineEdit(tabs[TbConfig]);
	commandToolTip->setGeometry(5,240,375,25);
	connect(commandToolTip,SIGNAL(textChanged(const QString &)),SLOT(toolTipChanged(const QString &)));
	

// Config abfragen
  QString ask;
	config->setGroup("Delete");
	ask = config->readEntry("ask","yes");
	if(ask == "yes")
		check[checkDelete]->setChecked(true);
	else
		check[checkDelete]->setChecked(false);

	config->setGroup("Copy");
	ask = config->readEntry("ask","yes");
	if(ask == "yes")
		check[checkCopying]->setChecked(true);
	else
		check[checkCopying]->setChecked(false);

	config->setGroup("Overwrite");
	ask = config->readEntry("ask","yes");
	if(ask == "yes")
		check[checkOverwrite]->setChecked(true);
	else
		check[checkOverwrite]->setChecked(false);

	config->setGroup("Quit");
	ask = config->readEntry("ask","yes");
	if(ask == "yes")
		check[checkQuit]->setChecked(true);
	else
		check[checkQuit]->setChecked(false);

	loadThisButton(0);
	// activate first button
	lb->setCurrentItem(0);

}
void wizzard::checkboxChanged(int status)
{
  QString s = sender()->name();
  int a = s.toInt();
  if(a>=0 && a<MAXCHECK)
  {
    switch(a)
    {
      case checkQuit:
      {
        config = kapp->config();
      	config->setGroup("Quit");
      	if(status==2)
        	config->writeEntry("ask","yes");
        else
        	config->writeEntry("ask","no");
      } break;
      case checkOverwrite:
      {
        config = kapp->config();
      	config->setGroup("Overwrite");
      	if(status==2)
        	config->writeEntry("ask","yes");
        else
        	config->writeEntry("ask","no");
      } break;
      case checkCopying:
      {
        config = kapp->config();
      	config->setGroup("Copy");
      	if(status==2)
        	config->writeEntry("ask","yes");
        else
        	config->writeEntry("ask","no");
      } break;
      case checkDelete:
      {
        config = kapp->config();
      	config->setGroup("Delete");
      	if(status==2)
        	config->writeEntry("ask","yes");
        else
        	config->writeEntry("ask","no");
      } break;
    }
  }
}
void wizzard::mailCfgChanged(const QString &string)
{
  QString s = sender()->name();
  int a = s.toInt();
  config = kapp->config();
	config->setGroup("MailConfig");
  switch(a)
  {
    case popServer:
      config->writeEntry("POP3",string);
      break;
    case mailServer:
      config->writeEntry("SMTP",string);
      break;
    case popName:
      config->writeEntry("POPNAME",string);
      break;
    case popPassword:
      config->writeEntry("POPPASS",string);
      break;
  }
}
void wizzard::fontDialog()
{
  // start at the current working directory and with *.cpp as filter
  bool ok;
  QFont f;
  f.setPointSize(12);
  f = QFontDialog::getFont( &ok, f,this );
  if ( ok )
  {
  // the user selected a valid font
  }
  else
  {
  // the user cancelled the dialog
    return;
  }

  QString s = sender()->name();
  int a = s.toInt();
  config = kapp->config();
	config->setGroup("FontConfig");
  s = QString("Font_") + s;
  config->writeEntry(s,f);

  label[fontDemo1 + a]->setFont(f);

}
// if the user clicked on a button entry in the listbox....
void wizzard::toolbuttonSelected(int index)
{
	actuellButton = index;
	loadThisButton(index);
}
void wizzard::setEditAble(bool flag)
{
	if(flag)
	{
	  // and enable the LineEdit's
		visibleBox->setEnabled(true);
		kcommanderBox->setEnabled(true);
		kcommanderCommands->setEnabled(true);
		commandToolTip->setEnabled(true);
		
	}
	else
	{
	  // and enable the LineEdit's
		visibleBox->setEnabled(false);
		kcommanderBox->setEnabled(false);
		kcommanderCommands->setEnabled(false);
		commandToolTip->setEnabled(false);
	}
}
void wizzard::openIconDlg()
{
		QString icon;
		iconDlg = new KIconDialog();
		icon = iconDlg->selectIcon();
		if(icon.length() != 0)
		{
	
	    KIconLoader *kil = new KIconLoader();
			iconButton->setPixmap(kil->loadIcon(icon,KIcon::Desktop));
			buttonName = icon;
			buttonLabel->setText(icon);
			saveIcon();
			setEditAble(true);
		}
		else
			buttonLabel->setText("");

}
void wizzard::kcommandChanged(int)
{
	// todo: change state of the inputline !!
	saveKCommand();
	if(kcommanderBox->isChecked())
	{
		kcommanderCommands->show();
		externCommand->hide();
	}
	else
	{
		kcommanderCommands->hide();
		externCommand->show();
	}
	saveKCommand();
}
void wizzard::loadThisButton(int index)
{
	// load all parameters of this button from config
	QString ask;
	ask.sprintf("tb_%d_iconName",index);
	config->setGroup("ToolButtons");
	ask = config->readEntry(ask,"");
	KIconLoader *kil = new KIconLoader();
	if(ask.length()==0)
	{
		iconButton->setPixmap(0L);
		setEditAble(false);
	}
	else
	{
		iconButton->setPixmap(kil->loadIcon(ask,KIcon::Desktop));
		buttonName = ask;
		setEditAble(true);
	}

	// now the flag if it is a kcommander command
	ask.sprintf("tb_%d_isKCcommand",index);
	kcommanderBox->setChecked(config->readBoolEntry(ask,false));
	// is the button visible ?	
	ask.sprintf("tb_%d_isVisible",index);
	visibleBox->setChecked(config->readBoolEntry(ask,true));
	ask.sprintf("tb_%d_KCcommandIndex",index);
	kcommanderCommands->setCurrentItem(config->readNumEntry(ask,0));
	ask.sprintf("tb_%d_ToolTip",index);
	commandToolTip->setText(config->readEntry(ask,""));
	ask.sprintf("tb_%d_Command",index);
	externCommand->setText(config->readEntry(ask,""));
}

void wizzard::saveIcon()
{
  config = kapp->config();
	config->setGroup("ToolButtons");
	QString s;
	s.sprintf("tb_%d_iconName",actuellButton);
	config->writeEntry(s, buttonName);
}
void wizzard::saveVisible(int)
{
	QString bt; bt.sprintf("_%d_",actuellButton);
  config = kapp->config();
	config->setGroup("ToolButtons");
	config->writeEntry("tb" + bt + "isVisible",visibleBox->isChecked());
}
void wizzard::saveKCommand()
{
	QString bt; bt.sprintf("_%d_",actuellButton);
  config = kapp->config();
	config->setGroup("ToolButtons");
	config->writeEntry("tb" + bt + "isKCcommand",kcommanderBox->isChecked());
}
void wizzard::saveKCindex(int)
{
	QString bt; bt.sprintf("_%d_",actuellButton);
  config = kapp->config();
	config->setGroup("ToolButtons");
	config->writeEntry("tb" + bt + "KCcommandIndex",kcommanderCommands->currentItem());
}
void wizzard::saveToolTip()
{
	QString bt; bt.sprintf("_%d_",actuellButton);
  config = kapp->config();
	config->setGroup("ToolButtons");
	config->writeEntry("tb" + bt + "ToolTip",commandToolTip->text());
}
void wizzard::saveCommand()
{
	QString bt; bt.sprintf("_%d_",actuellButton);
  config = kapp->config();
	config->setGroup("ToolButtons");
	config->writeEntry("tb" + bt + "Command",externCommand->text());
}
void wizzard::toolTipChanged(const QString &)
{
	saveToolTip();
}
void wizzard::commandChanged(const QString &)
{
	saveCommand();
}
void wizzard::slotPopFirstPressed(int state)
{
  config = kapp->config();
	config->setGroup("MailConfig");
  switch(state)
  {
    case 0:
      config->writeEntry("POPFIRST", false);
      break;
    case 2:
      config->writeEntry("POPFIRST", true);
      break;
  }
}

QString wizzard::getMailConfig(const char *name)
{
  QString result;
  KStandardDirs *dirs = KGlobal::dirs();
  QString config_path = dirs->findResourceDir("config","kmailrc");
  config_path += "kmailrc";
  KConfig KMailConfig(config_path);
  QString s(name);
  if(s == "Smtp Host")
    KMailConfig.setGroup("sending mail");
  else
    KMailConfig.setGroup("Account 1");
  result = KMailConfig.readEntry(name,"");
  return result;
}


const QString wizzard::encryptStr(const QString aStr) const
{
  unsigned int i,val;
  unsigned int len = aStr.length();
  QCString result;
  result.resize(len+1);

  for (i=0; i<len; i++)
  {
    val = aStr[i] - ' ';
    val = (255-' ') - val;
    result[i] = (char)(val + ' ');
  }
  result[i] = '\0';
  debug(result);

  return result;
}

/*
const QString KMAcctExpPop::encryptStr(const QString aStr) const
{
  unsigned int i, val;
  unsigned int len = aStr.length();
  QCString result;
  result.resize(len+1);

  for (i=0; i<len; i++)
  {
    val = aStr[i] - ' ';
    val = (255-' ') - val;
    result[i] = (char)(val + ' ');
  }
  result[i] = '\0';

  return result;
}    */
